Package com.ads.api.util

# Class MappingManagerUtil

java.lang.Object
com.ads.api.util.BaseUtil
com.ads.api.util.MappingManagerUtil

public class MappingManagerUtil extends com.ads.api.util.BaseUtil
Contains the methods related to perform the operations such as creation, update, deletion and retrieval of Projects, Mappings, Subjects, MappingSpecifications and Documents, cloneMapping, versioning the map, Baseline Project, Publish the mappings, upload mappings and export mappings. Some of the methods are of resizable-array implementations, Hash table based implementations and RequestStatus return Type.

Resizable-array Implements all optional list operations.Each ArrayList instance has a capacity. The capacity is the size of the array used to store the elements in the list. It is always at least as large as the list size.Hash table based implementation provides all of the optional map operations.

RequestStatus return type methods will result in being returned as either true or false as its status.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.ads.api.util.BaseUtil

  `com.ads.api.util.BaseUtil.TokenType`

- ## Field Summary

  ### Fields inherited from class com.ads.api.util.BaseUtil

  `AUTH_TOKEN, AUTH_TOKEN_TYPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `RequestStatus`
  `addMappingDocument(int mapId, Document document)`
  MappingDocument is added for the specified mapId.
  `RequestStatus`
  `addMappingDocument(int nodeId, Node.NodeType nodeType, String mapName, Document document)`
  MappingDocument is added for the specified mapName.
  `String`
  `addMappingDocumentAs(int mapId, String document, String outputFormat)`
  MappingDocument is added for the specified mapId.
  `String`
  `addMappingDocumentAs(int nodeId, String nodeType, String mapName, String document, String outputFormat)`
  MappingDocument is added for the specified mapName.
  `RequestStatus`
  `addMappingSpecification(int mapId, MappingSpecificationRow mappingSpecificationRow)`
  Inserts a single row of mappingSpecification for the specified mapId,mappingSpecificationRow.
  `String`
  `addMappingSpecificationAs(int mapId, String mmMapSpecRowObjJson, String outputFormat)`
  Inserts a single row of mappingSpecification for the specified mapId, mappingSpecificationRow.
  `RequestStatus`
  `addMappingSpecifications(int mapId, ArrayList<MappingSpecificationRow> mappingSpecification)`
  Inserts List of mappingSpecifications into the specified mapId.
  `String`
  `addMappingSpecificationsAs(int mapId, String mmMapSpecRowObjJsonArray, String outputFormat)`
  Inserts List of mappingSpecifications into the specified mapId.
  `RequestStatus`
  `baselineProject(int projectId, String versionLabel, String changeDescription)`
  Appends the baseline to the project for the specified projectId.
  `String`
  `baselineProjectAs(int projectId, String versionLabel, String changeDescription, String outputFormat)`
  Appends the baseline to the project for the specified projectId.
  `RequestStatus`
  `cloneMapping(int srcMapId, boolean createNewVersion, String newMapName, int tgtNodeId, Node.NodeType tgtnodeType)`
  Clone Mapping creates another copy of the map.
  `RequestStatus`
  `cloneMapping(int srcNodeId, Node.NodeType srcnodeType, String srcMapName, boolean createNewVersion, String newMapName, int tgtNodeId, Node.NodeType tgtnodeType)`
  Clone Mapping creates another copy of the map.
  `String`
  `cloneMappingAs(int srcMapId, boolean createNewVersion, String newMapName, int tgtNodeId, String tgtnodeType, String outputFormat)`
  Clone Mapping creates another copy of the map.
  `String`
  `cloneMappingAs(int srcNodeId, String srcnodeType, String srcMapName, boolean createNewVersion, String newMapName, int tgtNodeId, String tgtnodeType, String outputFormat)`
  Clone Mapping creates another copy of the map.
  `RequestStatus`
  `createMapping(Mapping mapping)`
  Creates Mapping With the specified Mapping Object.
  `RequestStatus`
  `createMapping(Mapping mapping, boolean addSpecifications)`
  Creates Mapping with the specified mapping object and addSpecifications.
  `String`
  `createMappingAs(String mmMappingObjJson, boolean addSpecifications, String outputFormat)`
  Creates Mapping for the specified mappingObject in the JSON and addSpecifications.
  `String`
  `createMappingAs(String mmMappingObjJson, String outputFormat)`
  Creates Mapping for the specified MappingObject in JSON.
  `RequestStatus`
  `createMappings(List<Mapping> mappings, boolean addSpecifications)`
  Creates Mappings with the specified mapping objects and addSpecifications.
  `RequestStatus`
  `createMappings(List<Mapping> mappings, int fillOptions)`
  Creates Mappings for the specified mapping objects and fillOptions.
  `String`
  `createMappingsAs(String mappings, boolean addSpecifications, String outputFormat)`
  Creates Mappings for the specified mapping objects,addSpecifications and outputFormat.
  `String`
  `createMappingsWithFillOptions(String mappings, int fillOptions, String outputFormat)`
  Creates Mappings for the specified mapping objects and fillOptions.
  `RequestStatus`
  `createProject(Project project)`
  Creates a project for the specified Project Object.
  `String`
  `createProjectAs(String mmProjectObjJson, String outputFormat)`
  Creates a project for the specified Project Object in JSON.
  `RequestStatus`
  `createSubject(int projectId, int parentSubjectId, String subjectName)`
  Creates Subject for the specified ProjectId, ParentSubjectId and SubjectName.
  `RequestStatus`
  `createSubject(int projectId, int parentSubjectId, String subjectName, String subjectDescription)`
  Creates Subject for the specified ProjectId, ParentSubjectId, SubjectName and Subject Description.
  `RequestStatus`
  `createSubject(Subject subject)`
  Creates Subject for the specified Subject Object.
  `String`
  `createSubjectAs(int projectId, int parentSubjectId, String subjectName, String outputFormat)`
  Creates Subject for the specified ProjectId, ParentSubjectId and subjectName in JSON.
  `String`
  `createSubjectAs(int projectId, int parentSubjectId, String subjectName, String subjectDescription, String outputFormat)`
  Creates Subject for the specified ProjectId, ParentSubjectId, SubjectName and SubjectDescription in JSON.
  `String`
  `createSubjectAs(String mmSubjectObjJson, String outputFormat)`
  Creates Subject for the specified SubjectObject in JSON.
  `RequestStatus`
  `deleteMapping(int mappingId)`
  Removes Mapping for the specified mappingId.
  `RequestStatus`
  `deleteMapping(int mapId, APIConstants.VersionMode versionMode, float versionNo)`
  Deletes the mapping of the specified mapId, versionMode.
  `RequestStatus`
  `deleteMapping(int nodeId, Node.NodeType nodeType, String mapName, APIConstants.VersionMode versionMode, float versionNo)`
  Deletes the map for the specified mapName of the given nodeType and nodeId.
  `String`
  `deleteMappingAs(int mappingId, String outputFormat)`
  Deletes Mapping for the specified mappingId.
  `String`
  `deleteMappingAs(int mapId, String versionMode, float versionNo, String outputFormat)`
  Deletes the mapping of the specified mapId and versionMode.
  `String`
  `deleteMappingAs(int nodeId, String nodeType, String mapName, String versionMode, float versionNo, String outputFormat)`
  Deletes the map for the specified mapName of the given nodeType and nodeId.
  `RequestStatus`
  `deleteMappings(int nodeId, Node.NodeType nodeType, APIConstants.VersionMode versionMode, float versionNo)`
  Deletes the mappings of the given nodeType and nodeId.
  `RequestStatus`
  `deleteMappings(int nodeId, Node.NodeType nodeType, List<String> mapNames, APIConstants.VersionMode versionMode, float versionNo)`
  Deletes the mappings of the specified List of mapNames of the given nodeType and nodeId.
  `RequestStatus`
  `deleteMappings(List<Integer> mappingIds, APIConstants.VersionMode versionMode, float versionNo)`
  Deletes the mappings of the specified mappingIds.
  `String`
  `deleteMappingsAs(int nodeId, String nodeType, String versionMode, float versionNo, String outputFormat)`
  Deletes the mappings of the given nodeType and nodeId.
  `String`
  `deleteMappingsAs(int nodeId, String nodeType, String mapNamesJsonArray, String versionMode, float versionNo, String outputFormat)`
  Deletes the mappings of the specified List of mapNames of the given nodeType and nodeId.
  `String`
  `deleteMappingsAs(String mappingIdsJsonArray, String versionMode, float versionNo, String outputFormat)`
  Deletes the mappings for the specified mappingIds.
  `RequestStatus`
  `deleteMappingSpecification(int mappingSequenceId)`
  Removes mappingSpecification for the specified mappingSequenceId.
  `String`
  `deleteMappingSpecificationAs(int mappingSequenceId, String outputFormat)`
  Deletes mappingSpecification for the specified mappingSequenceId.
  `RequestStatus`
  `deleteMappingSpecificationRow(MappingSpecificationRow mappingSpecificationRow)`
  Deletes the mappingSpecification for the specified mappingSpecificationRow Object.
  `String`
  `deleteMappingSpecificationRowAs(String mappingSpecificationRowJsonObj, String outputFormat)`
  Deletes the mappingSpecificationRow for the specified mappingSpecificationRow Object.
  `RequestStatus`
  `deleteMappingSpecificationRows(List<MappingSpecificationRow> mappingSpecificationRows)`
  Deletes the mappingSpecifications for the specified List of mappingSpecificationRows.
  `String`
  `deleteMappingSpecificationRowsAs(String mappingSpecificationRowsJsonArray, String outputFormat)`
  Deletes the mappingSpecifications for the specified List of mappingSpecificationRows.
  `RequestStatus`
  `deleteMappingSpecifications(int mappingId)`
  Removes all mappingSpecification rows for the specified mappingId.
  `RequestStatus`
  `deleteMappingSpecifications(List<Integer> mappingSequenceIds)`
  Deletes the mappingSpecifications for the specified List of mappingSequenceIds.Specifying the mappingSequenceIds are mandatory.
  `String`
  `deleteMappingSpecificationsAs(int mappingId, String outputFormat)`
  Deletes all mappingSpecification rows for the specified mappingId.
  `String`
  `deleteMappingSpecificationsAs(String mapSeqIdsJsonArray, String outputFormat)`
  Deletes the mappingSpecifications for the specified List of mapSequenceIds.
  `RequestStatus`
  `deleteProject(int projectId)`
  Deletes the project with the specified projectId.
  `String`
  `deleteProjectAs(int projectId, String outputFormat)`
  Deletes a project of the specified projectId.
  `RequestStatus`
  `deleteSubject(int subjectId)`
  Removes the subject of the specified subjectId.
  `String`
  `deleteSubjectAs(int subjectId, String outputFormat)`
  Deletes the subject for the specified subjectId.
  `RequestStatus`
  `exportAll(int nodeId, Node.NodeType nodeType, APIConstants.SelectionCriteria selectionCriteria, APIConstants.ExportOption exportOption, boolean includePseudoCode, boolean visibleColumns)`
  Mapping Specifications are exported to excel for the specified nodeId.
  `String`
  `exportAllAs(int nodeId, String nodeType, String selectionCriteria, String exportOption, boolean includePseudoCode, boolean visibleColumns, String outputFormat)`
  Mapping Specifications are exported to excel for the specified nodeId.
  `RequestStatus`
  `exportMappingToExcel(int mapId, boolean visibleColumns, boolean includePseudocode)`
  Mapping Specification is exported to excel for the specified mapId.
  `RequestStatus`
  `exportMappingToExcel(int nodeId, Node.NodeType nodeType, String mapName, boolean visibleColumns, boolean includePseudocode)`
  Mapping Specification is exported to excel for the specified mapName.
  `String`
  `exportMappingToExcelAs(int mapId, boolean visibleColumns, boolean includePseudocode, String outputFormat)`
  Mapping Specification is exported to excel for the specified mapId.Specifying the mapId is mandatory.
  `String`
  `exportMappingToExcelAs(int nodeId, String nodeType, String mapName, boolean visibleColumns, boolean includePseudocode, String outputFormat)`
  Mapping Specification is exported to excel for the specified mapName.
  `RequestStatus`
  `exportMappingXml(int nodeId, Node.NodeType nodeType, APIConstants.SelectionCriteria selectionCriteria)`
  Mapping Specifications are exported to XML for the specified nodeId.
  `String`
  `exportMappingXmlAs(int nodeId, String nodeType, String selectionCriteria, String outputFormat)`
  Mapping Specifications are exported to XML for the specified nodeId.
  `Mapping`
  `getMapping(int mappingId)`
  Returns Mapping Object for the specified mappingId.
  `Mapping`
  `getMapping(int mappingId, boolean fillSpecifications)`
  Returns Mapping Object for the specified mappingId and fillSpecifications.
  `Mapping`
  `getMapping(int mappingId, boolean fillSpecifications, boolean fillDocuments)`
  Returns Mapping Object for the specified mappingId, fillSpecifications and fillDocuments.
  `Mapping`
  `getMapping(int parentNodeId, Node.NodeType nodeType, String mappingName)`
  Returns Mapping Object for the specified parentNodeId, mappingName and nodeType.
  `Mapping`
  `getMapping(int nodeId, Node.NodeType nodeType, String mapName, float versionNo)`
  Returns all the information relating to the specified mapName, such as mappingDescription, mappingSpecVersion, mappingStatus,
  mappingPlannedDevelopmentEffort, actualEffort,testingNotes, versionLabel, userDefined Fields, AuditFields etc...
  `String`
  `getMappingAs(int mappingId, boolean fillSpecification, boolean fillDocuments, String outputFormat)`
  Returns Mapping Object for the specified mappingId, fillSpecifications, fillDocuments in the JSON.
  `String`
  `getMappingAs(int mappingId, boolean fillSpecification, String outputFormat)`
  Returns Mapping Object for the specified mappingId, fillSpecification in the JSON.
  `String`
  `getMappingAs(int mappingId, String outputFormat)`
  Returns Mapping Object for the specified mappingId in the specified outputFormat.
  `String`
  `getMappingAs(int nodeId, String nodeType, String mapName, float versionNo, String outputFormat)`
  Returns all the information relating to the specified mapName, such as mappingDescription, mappingSpecVersion, mappingStatus,
  mappingPlannedDevelopmentEffort, actualEffort,testingNotes, versionLabel, userDefined Fields, AuditFields etc...
  `String`
  `getMappingAs(int parentNodeId, String nodeType, String mappingName, String outputFormat)`
  Returns Mapping Object for the specified parentNodeId, mappingName, nodeType in the JSON.
  `ArrayList<Document>`
  `getMappingDocuments(int mappingId)`
  Returns the List of Mapping Document objects for the specified mappingId.
  `String`
  `getMappingDocumentsAs(int mappingId, String outputFormat)`
  Returns the List of Mapping Document objects for the specified mappingId.
  `int`
  `getMappingId(int parentNodeId, String mappingName, Node.NodeType nodeType)`
  Returns the mappingId for the specified parentNodeId, mappingName, nodeType.
  `int`
  `getMappingId(String projectName, String mappingName)`
  Returns the mappingId for the specified mappingName and projectName.
  `String`
  `getMappingIdAs(int parentNodeId, String nodeType, String mappingName, String outputFormat)`
  Returns the mappingId for the specified parentNodeId, mappingName, nodeType in the JSON.
  `String`
  `getMappingIdAs(String projectName, String mappingName, String outputFormat)`
  Returns the mappingId for the specified mappingName and projectName in the JSON.
  `ArrayList<Mapping>`
  `getMappings(int parentNodeId, Node.NodeType nodeType)`
  Returns the List of Mappings for the specified parentNodeId, nodeType.
  `ArrayList<Mapping>`
  `getMappings(List<Integer> mapIds, boolean fillSpecifications, boolean fillDocuments)`
  Returns List of Mappings for the specified List of mapIds.
  `String`
  `getMappingsAs(int parentNodeId, String nodeType, String outputFormat)`
  Returns List of Mappings for the specified parentNodeId, nodeType.
  `String`
  `getMappingsAs(String MapIdsJsonArray, boolean fillSpecifications, boolean fillDocuments, String outputFormat)`
  Returns List of Mappings for the specified List of mapIds.
  `ArrayList<Mapping>`
  `getMappingsInProject(int projectId, boolean fillSpecifications, boolean fillDocuments)`
  Returns List of Mappings for the specified projectId, fillSpecifications and fillDocuments.
  `ArrayList<Mapping>`
  `getMappingsInProject(String projectName, boolean fillSpecifications, boolean fillDocuments)`
  Returns List of mappings for the specified projectName, fillSpecifications, fillDocuments.
  `String`
  `getMappingsInProjectAs(int projectId, boolean fillSpecifications, boolean fillDocuments, String outputFormat)`
  Returns List of Mappings for the specified projectId, fillSpecifications, fillDocuments in the JSON.
  `String`
  `getMappingsInProjectAs(String projectName, boolean fillSpecifications, boolean fillDocuments, String outputFormat)`
  Returns List of mappings for the specified project Name, fillSpecifications, fillDocuments.
  `ArrayList<Mapping>`
  `getMappingsInSubject(int subjectId, boolean fillSpecifications, boolean fillDocuments)`
  Returns List of mappings for the specified for a given subject Id, fillSpecifications, fillDocuments.
  `ArrayList<Mapping>`
  `getMappingsInSubject(String subjectName, boolean fillSpecifications, boolean fillDocuments)`
  Returns List of all mappings from all projects containing the subject name at any level, fillSpecifications and fillDocuments.
  `String`
  `getMappingsInSubjectAs(int subjectId, boolean fillSpecifications, boolean fillDocuments, String outputFormat)`
  Returns List of mappings for the specified subject Id, fillSpecifications, fillDocuments in the JSON.
  `String`
  `getMappingsInSubjectAs(String subjectName, boolean fillSpecifications, boolean fillDocuments, String outputFormat)`
  Returns List of mappings for the specified subject Name, fillSpecifications, fillDocuments in the JSON.
  `ArrayList<MappingSpecificationRow>`
  `getMappingSpecifications(int mappingId)`
  Returns the List of Mapping Specifications for the specified mappingId.
  `List<MappingSpecificationRow>`
  `getMappingSpecifications(List<Integer> mappingSequenceIds)`
  Returns the List of MappingSpecification Rows for the specified List of mapSequenceIds.
  `String`
  `getMappingSpecificationsAs(int mappingId, String outputFormat)`
  Returns the List of Mapping Specifications for the specified mappingId.
  `String`
  `getMappingSpecificationsAs(String mapSeqIdsJsonArray, String outputFormat)`
  Returns the List of MappingSpecification Rows for the specified List of mapSequenceIds.
  `Project`
  `getProject(int projectId)`
  Returns the Project object for the specified project Id.Specifying the projectId is mandatory.
  `Project`
  `getProject(String projectName)`
  Returns the Project object for the specified project Name i.e all the respective details regarding the project,
  such as ProjectName, ProjectDescription, projectCostCenter, projectITSponsorFullName, projectBusinessSponsorFullName, projectDocuments, projectResources etc....Specifying the projectName is mandatory.
  `String`
  `getProjectAs(int projectId, String outputFormat)`
  Returns the Project object for the specified projectId in the specified outputFormat.
  `String`
  `getProjectAs(String projectName, String outputFormat)`
  Returns the Project object for the specified project Name in the specified outputFormat.
  `ArrayList<Document>`
  `getProjectDocuments(int projectId)`
  Returns the List of project documents for the specified projectId.
  `String`
  `getProjectDocumentsAs(int projectId, String outputFormat)`
  Returns the List of project Documents for the specified projectId in the specified outputFormat.
  `int`
  `getProjectId(String projectName)`
  Returns the projectId for the specified projectName.
  `String`
  `getProjectIdAs(String projectName, String outputFormat)`
  Returns the projectId for the specified projectName in the specified outputFormat.
  `List<Project>`
  `getProjects()`
  Returns the List of all Projects i.e all the respective details regarding projects, such as ProjectName, ProjectDescription, projectCostCenter, projectITSponsorFullName, projectBusinessSponsorFullName, projectDocuments, projectResources etc...
  `List<Project>`
  `getProjects(Node.Depth depth)`
  Returns the projects and its Details according to the specified Depth.
  `String`
  `getProjectsAs(String outputFormat)`
  Returns the List of all Projects where each project contains details like projectName, projectDescription, projectDocuments etc...
  `String`
  `getProjectsAs(String depth, String outputFormat)`
  Returns the projects and its Details according to the specified Depth.
  `Subject`
  `getSubject(int subjectId)`
  Returns the Subject Object for the specified subjectId.Specifying subjectId is mandatory.
  `Subject`
  `getSubject(int projectId, int parentSubjectId, String subjectName)`
  Returns Subject Object for the specified projectId, parentSubjectId, subjectName.
  `Subject`
  `getSubject(int projectId, String subjectHierarchy)`
  Returns Subject object for the specified projectId and subjectHierarchy.
  `Subject`
  `getSubject(String projectName, String subjectHierarchy)`
  Returns Subject object for the specified projectName and subjectHierarchy.
  `String`
  `getSubjectAs(int projectId, int parentSubjectId, String subjectName, String outputFormat)`
  Returns SubjectObject for the specified projectId, parentSubjectId, subjectName in the specified outputFormat.
  `String`
  `getSubjectAs(int subjectId, String outputFormat)`
  Returns SubjectObject for the specified subjectId in the specified outputFormat.
  `String`
  `getSubjectAs(int projectId, String subjectHierarchy, String outputFormat)`
  Returns Subject object for the specified projectId and subjectHierarchy.
  `String`
  `getSubjectAs(String projectName, String subjectHierarchy, String outputFormat)`
  Returns Subject object for the specified projectName and subjectHierarchy.
  `int`
  `getSubjectid(String projectName, String subjectHierarchy)`
  `int`
  `getSubjectId(int parentNodeId, Node.NodeType nodeType, String subjectName)`
  Returns the subjectId for the specified parentNodeId, subjectName, nodeType.
  `int`
  `getSubjectId(String projectName, String subjectName)`
  Returns subjectId for the specified projectName and SubjectName.
  `String`
  `getSubjectIdAs(int parentNodeId, String nodeType, String subjectName, String outputFormat)`
  Returns the subjectId for the specified parentNodeId, subjectName, nodeType.
  `String`
  `getSubjectIdAs(String projectName, String subjectName, String outputFormat)`
  Returns subjectId for the specified projectName, SubjectName.
  `List<Subject>`
  `getSubjects(int projectId)`
  Returns the List of subjects of the specified projectId.
  `List<Subject>`
  `getSubjects(String projectName)`
  Returns the List of subjects for the specified projectName.
  `String`
  `getSubjectsAs(int projectId, String outputFormat)`
  Returns the List of subjects for the specified projectId in the specified outputFormat.
  `String`
  `getSubjectsAs(String projectName, String outputFormat)`
  Returns the List of subjects for the specified projectName in the specified outputFormat.
  `RequestStatus`
  `mergeMapping(int srcMapId, int tgtMapId, boolean createNewVersion, String changeDescription)`
  Merge Mapping combines the mapping specifications of one map in to the other map.I.e it copies the map specified at srcMapId and merges with the map specified at tgtMapId.Specifying srcMapId and tgtMapId are mandatory.
  `RequestStatus`
  `mergeMapping(int srcNodeId, Node.NodeType srcNodeType, String srcMapName, int tgtNodeId, Node.NodeType tgtNodeType, String tgtMapName, boolean createNewVersion, String changeDescription)`
  Merge Mapping combines the mapping specifications of one map in to the other map.I.e it copies the map specified at srcNodeId with srcMapName and merges with the map specified at tgtNodeId with the name tgtMapName.
  `String`
  `mergeMappingAs(int srcMapId, int tgtMapId, boolean createNewVersion, String changeDescription, String outputFormat)`
  Merge Mapping combines the mapping specifications of one map in to the other map.I.e it copies the map specified at srcMapId and merges with the map specified at tgtMapId.Specifying srcMapId and tgtMapId are mandatory.
  `String`
  `mergeMappingAs(int srcNodeId, String srcNodeType, String srcMapName, int tgtNodeId, String tgtNodeType, String tgtMapName, boolean createNewVersion, String changeDescription, String outputFormat)`
  Merge Mapping combines the mapping specifications of one map in to the other map.I.e it copies the map specified at srcNodeId with srcMapName and merges with the map specified at tgtNodeId with the name tgtMapName.
  `RequestStatus`
  `moveMapping(int srcMapId, int tgtNodeId, Node.NodeType tgtnodeType, boolean replaceIfExists, String newMapName)`
  Move Mapping moves the map from srcMapId to the specified tgtNodeId.
  `RequestStatus`
  `moveMapping(int srcNodeId, Node.NodeType srcNodeType, String srcMapName, int tgtNodeId, Node.NodeType tgtnodeType, boolean replaceIfExists, String newMapName)`
  Move Mapping moves the map from srcNodeId to the specified tgtNodeId.
  `String`
  `moveMappingAs(int srcMapId, int tgtNodeId, String tgtnodeType, boolean replaceIfExists, String newMapName, String outputFormat)`
  Move Mapping moves the map from srcMapId to the specified tgtNodeId.
  `String`
  `moveMappingAs(int srcNodeId, String srcNodeType, String srcMapName, int tgtNodeId, String tgtnodeType, boolean replaceIfExists, String newMapName, String outputFormat)`
  Move Mapping moves the map from srcNodeId to the specified tgtNodeId.
  `RequestStatus`
  `publishMapping(int nodeId, Node.NodeType nodeType, String mapName, Date effectiveDate, String changeDescription, String publishNotes)`
  Mapping is published for the specified mapName.specifying the mapName, effectiveDate, changeDescription, publishNotes are mandatory.
  `RequestStatus`
  `publishMapping(int mapId, Date effectiveDate, String changeDescription, String publishNotes)`
  Mapping is published for the specified mapId.
  `String`
  `publishMappingAs(int nodeId, String nodeType, String mapName, Date effectiveDate, String changeDescription, String publishNotes, String outputFormat)`
  Mapping is published for the specified mapName.specifying the mapName, effectiveDate, changeDescription, publishNotes are mandatory.
  `String`
  `publishMappingAs(int mapId, Date effectiveDate, String changeDescription, String publishNotes, String outputFormat)`
  Mapping is published for the specified mapId.specifying the mapId, effectiveDate, changeDescription, publishNotes are mandatory.
  `RequestStatus`
  `publishMappings(List<Integer> mapIds, Date effectiveDate, String changeDescription, String publishNotes)`
  Mappings will be published for the specified mapIds.
  `String`
  `publishMappingsAs(String mapIdsJsonArray, Date effectiveDate, String changeDescription, String publishNotes, String outputFormat)`
  Mappings will be published for the specified mapIds in the JSON.
  `RequestStatus`
  `setMappingLock(int mapId, boolean lockStatus)`
  mappingLock can be either set to lock or unlock i.e to either true or false for the specified mapId.
  `RequestStatus`
  `setMappingLock(int nodeId, Node.NodeType nodeType, String mapName, boolean lockStatus)`
  mappingLock can be either set to lock or unlock i.e to either true or false for the specified mapName.
  `String`
  `setMappingLockAs(int mapId, boolean lockStatus, String outputFormat)`
  mappingLock can be either set to lock or unlock for the specified mapId.
  `String`
  `setMappingLockAs(int nodeId, String nodeType, String mapName, boolean lockStatus, String outputFormat)`
  mappingLock can be either set to lock or unlock for the specified mapName.
  `RequestStatus`
  `syncMetadata(List<Integer> mappingIds)`
  This function is used to sync the source and target metadata information in mapping specifications for the specified mappingIds.
  `String`
  `syncMetadataAs(String mapIdsJsonArray, String outputFormat)`
  This function is used to sync the source and target metadata information in mapping specifications for the specified mapIds.
  `RequestStatus`
  `unPublishMap(int mapId)`
  Mapping is unpublished for the specified mapId.
  `RequestStatus`
  `unPublishMap(int nodeId, Node.NodeType nodeType, String mapName, float versionNo)`
  Mapping is unpublished for the specified nodeId.Specifying the nodeId, nodeType are mandatory.
  `String`
  `unPublishMapAs(int mapId, String outputFormat)`
  Mapping is unpublished for the specified mapId.Specifying the mapId is mandatory.
  `String`
  `unPublishMapAs(int nodeId, String nodeType, String mapName, float versionNo, String outputFormat)`
  Mapping is unpublished for the specified nodeId.Specifying the nodeId, nodeType are mandatory.
  `RequestStatus`
  `updateMapping(Mapping mapping)`
  Updates mapping for the specified Mapping Object.
  `String`
  `updateMappingAs(String mmMappingObjJson, String outputFormat)`
  Updates mapping for the specified MappingObject in JSON .
  `RequestStatus`
  `updateMappingSpecification(MappingSpecificationRow mappingSpecificationRow)`
  Mapping Specification is updated as the specified mappingSpecificationRow.
  `String`
  `updateMappingSpecificationAs(String mappingSpecificationRowJsonObj, String outputFormat)`
  Mapping Specification is updated with the specified mappingSpecificationRow object.
  `RequestStatus`
  `updateMappingSpecifications(List<MappingSpecificationRow> mappingSpecificationRows)`
  Mapping Specifications are updated as specified in List of mappingSpecificationRows.
  `String`
  `updateMappingSpecificationsAs(String mappingSpecificationRowJsonArray, String outputFormat)`
  Mapping Specifications are updated as specified in List of mappingSpecificationRows.Specifying mappingIds, mappingSequenceIds are modified.
  `RequestStatus`
  `updateProject(Project project)`
  Updates the project with the specified Project Object.
  `String`
  `updateProjectAs(String mmProjectObjJson, String outputFormat)`
  Updates project for the specified Project Object in JSON .
  `RequestStatus`
  `updateSubject(Subject subject)`
  Updates Subject Details for the specified Subject Object.
  `String`
  `updateSubjectAs(String mmSubjectObjJson, String outputFormat)`
  Updates Subject Details for the specified SubjectObject in JSON.
  `RequestStatus`
  `updateSubjects(List<Subject> subjects)`
  `RequestStatus`
  `uploadMapping(int nodeId, Node.NodeType nodeType, MappingImportHelper mappingImportHelper)`
  Uploads the mappingSpecifications on the specified nodeId, nodeType of importFileType, importType specified in MappingImportHelper Object.
  `RequestStatus`
  `uploadMapping(int mapId, MappingImportHelper mappingImportHelper)`
  Uploads the mappingSpecifications on the specified mapId of importFileType, importType specified in MappingImportHelper Object.
  `String`
  `uploadMappingAs(int mapId, String mappingImportHelperObjJson, String outputFormat)`
  Uploads the mappingSpecifications on the specified mapId and of the importFileType, importType specified in MappingImportHelper Object.
  `String`
  `uploadMappingAs(int nodeId, String nodeType, String mappingImportHelperObjJson, String outputFormat)`
  Uploads the mappingSpecifications on the specified nodeId, nodeType and of the importFileType, importType specified in MappingImportHelper Object.
  `RequestStatus`
  `versionMapping(Mapping mapping)`
  Appends mapping version for the specified Mapping Object.
  `String`
  `versionMappingAs(String mmMappingObjJson, String outputFormat)`
  Appends version to the mapping for the specified MappingObject in JSON.

  ### Methods inherited from class com.ads.api.util.BaseUtil

  `getAccessToken, getAccessTokenType, getTokenType, getUserDetails, permissionDeniedMessage, permissionDeniedStatus, setAccessToken, setAccessTokenType`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### createProject

    public RequestStatus createProject(Project project)
    Creates a project for the specified Project Object.
    Specifying the projectName field is mandatory along with the other information regarding project. If Project is added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `project` - Object
    Returns:
      RequestStatus object
    Since:
      6.2

  - ### getProjects

    public List<Project> getProjects() throws Exception
    Returns the List of all Projects i.e all the respective details regarding projects, such as ProjectName, ProjectDescription, projectCostCenter, projectITSponsorFullName, projectBusinessSponsorFullName, projectDocuments, projectResources etc...
    Returns:
      project List
    Throws:
      `Exception`
    Since:
      6.2

  - ### getProject

    public Project getProject(String projectName) throws Exception
    Returns the Project object for the specified project Name i.e all the respective details regarding the project,
    such as ProjectName, ProjectDescription, projectCostCenter, projectITSponsorFullName, projectBusinessSponsorFullName, projectDocuments, projectResources etc....Specifying the projectName is mandatory.
    Parameters:
      `projectName` - String
    Returns:
      Project Object
    Throws:
      `Exception`
    Since:
      6.2

  - ### getProject

    public Project getProject(int projectId) throws Exception
    Returns the Project object for the specified project Id.Specifying the projectId is mandatory.
    It returns the details like projectName, projectDescription, costCenter, projectOwnerName, sponserName, businessSponserName, projectDocument details and projectResources details.
    Parameters:
      `projectId` - int
    Returns:
      Project Object
    Throws:
      `Exception`
    Since:
      6.2

  - ### getProjectId

    public int getProjectId(String projectName) throws Exception
    Returns the projectId for the specified projectName. Specifying the projectName is mandatory.
    Parameters:
      `projectName` - String
    Returns:
      int - projectId
    Throws:
      `Exception`
    Since:
      6.2

  - ### getProjectDocuments

    public ArrayList<Document> getProjectDocuments(int projectId) throws Exception
    Returns the List of project documents for the specified projectId.
    Specification of projectId is mandatory, based on which it returns the list of all documents and their information such as documentName, documentType, documentOwner, documentObject, filePathType etc... present in that particular project. The filePath in the returned document object is RELATIVE.
    Parameters:
      `projectId` - int
    Returns:
      List of Document object.
    Throws:
      `Exception`
    Since:
      6.2

  - ### updateProject

    public RequestStatus updateProject(Project project)
    Updates the project with the specified Project Object. All the information pertaining to the project can be updated. Specifying the projectId, projectName are mandatory to update the project.
    If Project details are updated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `project` - ProjectObject
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### deleteProject

    public RequestStatus deleteProject(int projectId)
    Deletes the project with the specified projectId. Specifying the projectId is mandatory to delete a particular project.
    If Project is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `projectId` - int
    Returns:
      RequestStatus object
    Since:
      6.2

  - ### createMapping

    public RequestStatus createMapping(Mapping mapping)
    Creates Mapping With the specified Mapping Object. Specifying the ProjectId, MappingName values are Mandatory.
    If Mapping details are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `mapping` - MappingObject
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### createMappings

    public RequestStatus createMappings(List<Mapping> mappings, boolean addSpecifications)
    Creates Mappings with the specified mapping objects and addSpecifications. Specifying the ProjectId, MappingName values are Mandatory.
    If the value of addSpecifications is true, mappings gets created with all the specification details provided.If the value of addSpecifications is false only empty mappings with out any specifications gets created.
    If mapping details are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `mappings` - List of mapping objects
      `addSpecifications` - Boolean
    Returns:
      RequestStatus Object
    Since:
      10.2

  - ### createMappings

    public RequestStatus createMappings(List<Mapping> mappings, int fillOptions)
    Creates Mappings for the specified mapping objects and fillOptions.
    Specifying projectId and mappingName are mandatory in each mapping object.
    Here fillOptions can be Integer values of either `APIConstants.MMFillOptions.MAPPING_SPECIFICATIONS` or `APIConstants.MMFillOptions.MAPPING_DOCUMENTS` or `APIConstants.MMFillOptions.MAPPING_EXTENDED_PROPERTIES` for example: If you want to add mappings along with mapping specifications and documents you need to pass the fillOptions parameter value as 3 (MAPPING_SPECIFICATIONS(1) + MAPPING_DOCUMENTS(2)).
    If mapping details are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `mappings` - List of mapping objects
      `fillOptions` - `APIConstants.MMFillOptions` int
    Returns:
      RequestStatus Object
    Since:
      13.0

  - ### createMapping

    public RequestStatus createMapping(Mapping mapping, boolean addSpecifications)
    Creates Mapping with the specified mapping object and addSpecifications. Specifying the ProjectId, mappingName values are mandatory.
    If the value of addSpecifications is true, mapping gets created with all the specification details provided.If the value of addSpecifications is false only empty mapping with out any specifications gets created.
    If mapping details are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `mapping` - MappingObject
      `addSpecifications` - boolean
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### getMappings

    public ArrayList<Mapping> getMappings(int parentNodeId, Node.NodeType nodeType) throws Exception
    Returns the List of Mappings for the specified parentNodeId, nodeType. Specification of parentNodeId and nodeType is mandatory.
    If the nodeType is MM_PROJECT then the parentNodeId will be projectId and if nodeType is MM_SUBJECT then the parentNodeId will be subjectId.
    Parameters:
      `parentNodeId` - int
      `nodeType` - Node - valid types - MM_PROJECT, MM_SUBJECT
    Returns:
      List of mappings
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMapping

    public Mapping getMapping(int mappingId, boolean fillSpecifications, boolean fillDocuments) throws Exception
    Returns Mapping Object for the specified mappingId, fillSpecifications and fillDocuments. Specifying the mappingId is mandatory.
    Specifying the values of fillSpecifications and fillDocuments as true will return all the details pertaining to all the mappings in project, specifications and Document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `mappingId` - int
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
    Returns:
      Mapping Object
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMapping

    public Mapping getMapping(int mappingId, boolean fillSpecifications) throws Exception
    Returns Mapping Object for the specified mappingId and fillSpecifications. Specifying mappingId is mandatory.
    Parameters:
      `mappingId` - int
      `fillSpecifications` - boolean
    Returns:
      Mapping Object
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMapping

    public Mapping getMapping(int mappingId) throws Exception
    Returns Mapping Object for the specified mappingId.
    Parameters:
      `mappingId` - int
    Returns:
      Mapping Object
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMapping

    public Mapping getMapping(int parentNodeId, Node.NodeType nodeType, String mappingName) throws Exception
    Returns Mapping Object for the specified parentNodeId, mappingName and nodeType.
    Specification of parentNodeId, mappingName and nodeType are mandatory. NodeType can be either MM_PROJECT or MM_SUBJECT. Depending on the nodeType the parentNodeId can be Project Id, Subject Id respectively.
    Parameters:
      `parentNodeId` - int
      `mappingName` - String
      `nodeType` - NodeType - valid types - MM_PROJECT, MM_SUBJECT
    Returns:
      Mapping Object
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMappingId

    public int getMappingId(int parentNodeId, String mappingName, Node.NodeType nodeType) throws Exception
    Returns the mappingId for the specified parentNodeId, mappingName, nodeType.
    The value of nodeType can be MM_SUBJECT or MM_PROJECT.Depending on the nodeType, parentNodeId changes.
    If the nodeType is MM_SUBJECT, parentNodeId will be subjectId and if the nodeType is MM_PROJECT then parentNodeId will be projectId.
    Parameters:
      `parentNodeId` - int
      `mappingName` - String
      `nodeType` - Node - valid types - MM_PROJECT, MM_SUBJECT
    Returns:
      int - mappingId
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMappingId

    public int getMappingId(String projectName, String mappingName) throws Exception
    Returns the mappingId for the specified mappingName and projectName. Specifying the projectName and mappingName are mandatory.
    Parameters:
      `projectName` - String
      `mappingName` - String
    Returns:
      int - mappingId
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMappingDocuments

    public ArrayList<Document> getMappingDocuments(int mappingId) throws Exception
    Returns the List of Mapping Document objects for the specified mappingId.
    Specification of mappingId is mandatory, based on which it returns the list of all documents and their information present in that particular mapping.The filePath in the returned document object is RELATIVE.
    Parameters:
      `mappingId` - int
    Returns:
      List of Document object.
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMappingsInProject

    public ArrayList<Mapping> getMappingsInProject(String projectName, boolean fillSpecifications, boolean fillDocuments) throws Exception
    Returns List of mappings for the specified projectName, fillSpecifications, fillDocuments.
    Specifying the values of fillSpecifications and fillDocuments as true will return all the details pertaining to all the mappings, specifications and Document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `projectName` - String
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
    Returns:
      List of MappingObject
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMappingsInProject

    public ArrayList<Mapping> getMappingsInProject(int projectId, boolean fillSpecifications, boolean fillDocuments) throws Exception
    Returns List of Mappings for the specified projectId, fillSpecifications and fillDocuments.
    Specifying the values of fillSpecifications and fillDocuments as true will return all the details pertaining to all the mappings, specifications and Document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `projectId` - int
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
    Returns:
      List of MappingObject
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMappingsInSubject

    public ArrayList<Mapping> getMappingsInSubject(String subjectName, boolean fillSpecifications, boolean fillDocuments) throws Exception
    Returns List of all mappings from all projects containing the subject name at any level, fillSpecifications and fillDocuments. Specifying the subjectName is mandatory.
    Specifying the values of fillSpecifications and fillDocuments as true will return all the details pertaining to all the mappings of the subject, specifications and Document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `subjectName` - String
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
    Returns:
      List of mappingObject
    Throws:
      `Exception`
    Since:
      6.2

  - ### getMappingsInSubject

    public ArrayList<Mapping> getMappingsInSubject(int subjectId, boolean fillSpecifications, boolean fillDocuments) throws Exception
    Returns List of mappings for the specified for a given subject Id, fillSpecifications, fillDocuments. Specifying the subjectId is mandatory.
    Specifying the values of fillSpecifications and fillDocuments as true will return all the details pertaining to all the mappings in subject, specifications and Document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `subjectId` - int
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
    Returns:
      List of MappingObject
    Throws:
      `Exception`
    Since:
      6.2

  - ### updateMapping

    public RequestStatus updateMapping(Mapping mapping)
    Updates mapping for the specified Mapping Object. Specifying the projectId, mappingId are mandatory.
    All the specifications pertaining to mapping can be updated. The information which needs to be updated should be provided through mapping Object.
    If Mapping details are updated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `mapping` - MappingObject
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### deleteMapping

    public RequestStatus deleteMapping(int mappingId)
    Removes Mapping for the specified mappingId. Specifying mappingId is mandatory to delete a particular mapping.
    If Mapping details are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `mappingId` - int
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### addMappingSpecifications

    public RequestStatus addMappingSpecifications(int mapId, ArrayList<MappingSpecificationRow> mappingSpecification)
    Inserts List of mappingSpecifications into the specified mapId.
    Specifying the mapId and List of mappingSpecifications are mandatory,all the mappingSpecifications will get inserted in to the map of the particular mapId.
    If Mapping Specifications are added successfully then RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `mapId` - int
      `mappingSpecification` - List
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### addMappingSpecification

    public RequestStatus addMappingSpecification(int mapId, MappingSpecificationRow mappingSpecificationRow)
    Inserts a single row of mappingSpecification for the specified mapId,mappingSpecificationRow. Specifying the mapId and mappingSpecificationRow are mandatory.
    If the mappingSpecificationRow is added successfully then RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `mapId` - int
      `mappingSpecificationRow` - Object
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### getMappingSpecifications

    public ArrayList<MappingSpecificationRow> getMappingSpecifications(int mappingId) throws Exception
    Returns the List of Mapping Specifications for the specified mappingId.
    Specifying the mappingId is mandatory, based on which it returns all the individual maps present in that particular mapping.
    Parameters:
      `mappingId` - int
    Returns:
      List of MappingSpecifications
    Throws:
      `Exception`
    Since:
      6.2

  - ### deleteMappingSpecifications

    public RequestStatus deleteMappingSpecifications(int mappingId)
    Removes all mappingSpecification rows for the specified mappingId. Specifying mappingId is mandatory.
    Parameters:
      `mappingId` - int
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### deleteMappingSpecification

    public RequestStatus deleteMappingSpecification(int mappingSequenceId)
    Removes mappingSpecification for the specified mappingSequenceId. Specifying the mappingSequenceId is mandatory.It removes a particular sequence of map based on the map sequenceId.
    Parameters:
      `mappingSequenceId` - int
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### createSubject

    public RequestStatus createSubject(Subject subject)
    Creates Subject for the specified Subject Object. Specifying ProjectId, SubjectId, Subject Name are Mandatory. If Subject details are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `subject` - Subject
    Returns:
      RequestStatus object
    Since:
      6.2

  - ### updateSubjects

    public RequestStatus updateSubjects(List<Subject> subjects)

  - ### getSubjects

    public List<Subject> getSubjects(String projectName) throws Exception
    Returns the List of subjects for the specified projectName.
    Specification of projectName is mandatory, based on which it returns the list of all subjects and their information present in that particular project.
    Parameters:
      `projectName` - String
    Returns:
      List of subjects
    Throws:
      `Exception`
    Since:
      6.2

  - ### getSubjects

    public List<Subject> getSubjects(int projectId) throws Exception
    Returns the List of subjects of the specified projectId.
    Specification of projectId is mandatory, based on which it returns the list of all subjects and their information present in that particular project.
    Parameters:
      `projectId` - int
    Returns:
      List of Subjects
    Throws:
      `Exception`
    Since:
      6.2

  - ### getSubject

    public Subject getSubject(int subjectId) throws Exception
    Returns the Subject Object for the specified subjectId.Specifying subjectId is mandatory. It returns all the details pertaining to the subject such as subjectId, subjectName, subjectDescription and auditHistory.
    Parameters:
      `subjectId` - int
    Returns:
      Subject Object
    Throws:
      `Exception`
    Since:
      6.2

  - ### getSubject

    public Subject getSubject(int projectId, int parentSubjectId, String subjectName) throws Exception
    Returns Subject Object for the specified projectId, parentSubjectId, subjectName. Specifying the projectId, parentSubjectId, subjectName are mandatory.Based on which it returns all the details of subject.
    Parameters:
      `projectId` - int
      `parentSubjectId` - int
      `subjectName` - String
    Returns:
      Subject Object
    Throws:
      `Exception`
    Since:
      6.2

  - ### getSubjectId

    public int getSubjectId(String projectName, String subjectName) throws Exception
    Returns subjectId for the specified projectName and SubjectName.
    Returns the subjectId of a particular subjectName present in a specific project.
    Parameters:
      `projectName` - String
      `subjectName` - String
    Returns:
      int - subjectId
    Throws:
      `Exception`
    Since:
      6.2

  - ### getSubjectId

    public int getSubjectId(int parentNodeId, Node.NodeType nodeType, String subjectName) throws Exception
    Returns the subjectId for the specified parentNodeId, subjectName, nodeType. Specifying the subjectName and parentnodeId is mandatory.
    The value of nodeType can be MM_SUBJECT or MM_PROJECT.Based on the nodeType, parentNodeId changes.
    If the nodeType is MM_SUBJECT, parentNodeId will be subjectId and if the nodeType is MM_PROJECT then parentNodeId will be projectId.
    Parameters:
      `parentNodeId` - int
      `subjectName` - String
      `nodeType` - Node
    Returns:
      int - subjectId
    Throws:
      `Exception`
    Since:
      6.2

  - ### updateSubject

    public RequestStatus updateSubject(Subject subject)
    Updates Subject Details for the specified Subject Object. All the subject information can be updated by providing the details in subject Object. Specifying SubjectId, Subject Name and ConsiderUserDefined Flag are mandatory.
    If Subject details are updated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `subject` - Subject
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### deleteSubject

    public RequestStatus deleteSubject(int subjectId)
    Removes the subject of the specified subjectId. Specifying the subjectId is mandatory to delete the subject.
    If Subject details are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `subjectId` - int
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### versionMapping

    public RequestStatus versionMapping(Mapping mapping)
    Appends mapping version for the specified Mapping Object.
    Appends a new version to the mappings,specifying the ProjectId, MapId, ChangeDescription Mandatory along with the other details of Mapping Object.
    If map version is successful, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `mapping` - Mapping
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### baselineProject

    public RequestStatus baselineProject(int projectId, String versionLabel, String changeDescription)
    Appends the baseline to the project for the specified projectId.
    Adds baseline to the project basing the type of versionLabel and Specification of the ProjectId , Version Label and Change Description are Mandatory.
    If baseLine is done successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `projectId` - int
      `versionLabel` - String
      `changeDescription` - String
    Returns:
      RequestStatus Object
    Since:
      6.2

  - ### createProjectAs

    public String createProjectAs(String mmProjectObjJson, String outputFormat)
    Creates a project for the specified Project Object in JSON. Specification of the outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the projectId, projectName are Mandatory along with the other information regarding project.
    Parameters:
      `mmProjectObjJson` - in JSON format
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Project is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmProjectObjJson' JSON :
      {
      "projectDescription": "",
      "projectName": "",
      "projectCostCenter": "",
      "projectOwnerFullName": "",
      "projectBusinessSponsorFullName": "",
      "projectDocuments": [],
      "projectResources": [
      {
      "resourceId": "",
      "roleId": "",
      "assignedRole": "",
      "assignedResponsibilites": null
      },
      {
      "resourceId": "",
      "roleId": "",
      "assignedRole": "",
      "assignedResponsibilites": null
      }
      ],
      "projectITSponsorFullName": "",
      "nodeId": "",
      "projectId": 0
      }

    Since:
      6.2

  - ### getProjectAs

    public String getProjectAs(int projectId, String outputFormat)
    Returns the Project object for the specified projectId in the specified outputFormat. outputFormat can be either JSON or XML.
    Specifying the projectId is Mandatory, based on which it returns the details like projectName, projectDescription, costCenter, projectOwnerName, sponserName, businessSponserName, projectDocument details and projectResources details.
    Parameters:
      `projectId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Project Object in the form of JSON or XML
    Since:
      6.2

  - ### getProjectAs

    public String getProjectAs(String projectName, String outputFormat)
    Returns the Project object for the specified project Name in the specified outputFormat.
    Specifying the projectName is Mandatory, Based on which it returns the details like projectName, projectDescription, costCenter, projectOwnerName, sponserName, businessSponserName, projectDocument details and projectResources details.
    Parameters:
      `projectName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Project Object in the form of JSON String or XML.
    Since:
      6.2

  - ### getProjectIdAs

    public String getProjectIdAs(String projectName, String outputFormat)
    Returns the projectId for the specified projectName in the specified outputFormat. Specifying the projectName is Mandatory. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `projectName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - projectId
    Since:
      6.2

  - ### getProjectsAs

    public String getProjectsAs(String outputFormat)
    Returns the List of all Projects where each project contains details like projectName, projectDescription, projectDocuments etc... outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Project Objects in the form of JSON String.
    Since:
      6.2

  - ### getProjectDocumentsAs

    public String getProjectDocumentsAs(int projectId, String outputFormat)
    Returns the List of project Documents for the specified projectId in the specified outputFormat.
    Specification of projectId is mandatory, based on the specified projectId it returns the list of all associated documents where each document contains details like documentName,documentOwner, documentObject, filePathType and documentLink etc. The filePath in the returned document object is RELATIVE.
    Parameters:
      `projectId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Document objects in the form of JSON or XML String.
    Since:
      6.2

  - ### updateProjectAs

    public String updateProjectAs(String mmProjectObjJson, String outputFormat)
    Updates project for the specified Project Object in JSON . All the information pertaining to the project can be updated. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectId, projectName are Mandatory.
    Parameters:
      `mmProjectObjJson` - mmProject Object - JSON format
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Project is updated successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmProjectObjJson' JSON :
      {
      "projectDescription": "",
      "projectName": "",
      "projectCostCenter": "",
      "projectOwnerFullName": "",
      "projectBusinessSponsorFullName": "",
      "projectDocuments": [],
      "projectResources": [
      {
      "resourceId": "",
      "roleId": "",
      "assignedRole": "",
      "assignedResponsibilites": null
      },
      {
      "resourceId": "",
      "roleId": "",
      "assignedRole": "",
      "assignedResponsibilites": null
      }
      ],
      "projectITSponsorFullName": "",
      "nodeId": "",
      "projectId": 0
      }

    Since:
      6.2

  - ### deleteProjectAs

    public String deleteProjectAs(int projectId, String outputFormat)
    Deletes a project of the specified projectId. Specifying projectId is mandatory to delete a particular project.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `projectId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Project is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### createSubjectAs

    public String createSubjectAs(String mmSubjectObjJson, String outputFormat)
    Creates Subject for the specified SubjectObject in JSON. outputFormat can be JSON or XML.
    Specifying projectId , subjectName are Mandatory to create a subject.
    Parameters:
      `mmSubjectObjJson` - mmSubject Object - JSON format
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Subject is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmSubjectObjJson' JSON :
      {
      "parentSubjectId": -1,
      "subjectId": 0,
      "userDefined10": "",
      "subjectDescription": "",
      "userDefined11": "",
      "userDefined12": "",
      "subjectName": "S1",
      "subjectChangedDescription": "",
      "userDefined13": "",
      "userDefined14": "",
      "userDefined15": "",
      "considerUserDefinedFlag": "",
      "userDefined8": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "projectId": 0,
      "userDefined1": ""
      }

    Since:
      6.2

  - ### getSubjectAs

    public String getSubjectAs(int projectId, int parentSubjectId, String subjectName, String outputFormat)
    Returns SubjectObject for the specified projectId, parentSubjectId, subjectName in the specified outputFormat. outputFormat can be JSON or XML.
    Specifying the projectId, parentSubjectId, subjectName are Mandatory.Based on which it returns all the details of subject.
    Parameters:
      `projectId` - int
      `parentSubjectId` - int
      `subjectName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Subject object in the form of JSON String.
    Since:
      6.2

  - ### getSubjectAs

    public String getSubjectAs(int subjectId, String outputFormat)
    Returns SubjectObject for the specified subjectId in the specified outputFormat. Specifying the subjectId is Mandatory based on which the subject Object is retrieved.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `subjectId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Subject object in the form of JSON or XML String.
    Since:
      6.2

  - ### getSubjectsAs

    public String getSubjectsAs(String projectName, String outputFormat)
    Returns the List of subjects for the specified projectName in the specified outputFormat. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specification of projectName is Mandatory, based on which it returns the list of all subjects and their information present in that particular project.
    Parameters:
      `projectName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Subject objects in the form of JSON or XML String.
    Since:
      6.2

  - ### getSubjectIdAs

    public String getSubjectIdAs(int parentNodeId, String nodeType, String subjectName, String outputFormat)
    Returns the subjectId for the specified parentNodeId, subjectName, nodeType. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    The value of nodeType can be MM_SUBJECT or MM_PROJECT.Based on the nodeType, parentNodeId changes.
    If the nodeType is MM_SUBJECT, parentNodeId will be subjectId whereas if the nodeType is MM_PROJECT then parentNodeId will be projectId.
    Parameters:
      `parentNodeId` - int
      `subjectName` - String
      `nodeType` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - subjectId in the form of JSON or XML
    Since:
      6.2

  - ### getSubjectIdAs

    public String getSubjectIdAs(String projectName, String subjectName, String outputFormat)
    Returns subjectId for the specified projectName, SubjectName. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectName, subjectName are Mandatory.
    Parameters:
      `projectName` - String
      `subjectName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - subjectId in the form of JSON or XML
    Since:
      6.2

  - ### getSubjectsAs

    public String getSubjectsAs(int projectId, String outputFormat)
    Returns the List of subjects for the specified projectId in the specified outputFormat. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specification of projectId is mandatory, based on which it returns the list of all subjects and their information present in that particular project.
    Parameters:
      `projectId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Subjects in the form of JSON or XML String.
    Since:
      6.2

  - ### updateSubjectAs

    public String updateSubjectAs(String mmSubjectObjJson, String outputFormat)
    Updates Subject Details for the specified SubjectObject in JSON. All the subject information can be updated by providing the details in subject Object.
    Specifying subjectId, subjectName are Mandatory. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mmSubjectObjJson` - mmSubject Object - JSON format
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Subject is updated successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmSubjectObjJson' JSON :
      {
      "parentSubjectId": -1,
      "subjectId": 0,
      "userDefined10": "",
      "subjectDescription": "",
      "userDefined11": "",
      "userDefined12": "",
      "subjectName": "S1",
      "subjectChangedDescription": "",
      "userDefined13": "",
      "userDefined14": "",
      "userDefined15": "",
      "considerUserDefinedFlag": "",
      "userDefined8": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "projectId": 0,
      "userDefined1": ""
      }

    Since:
      6.2

  - ### deleteSubjectAs

    public String deleteSubjectAs(int subjectId, String outputFormat)
    Deletes the subject for the specified subjectId. Specifying the subjectId is mandatory to delete the subject.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `subjectId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Subject is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### createMappingAs

    public String createMappingAs(String mmMappingObjJson, String outputFormat)
    Creates Mapping for the specified MappingObject in JSON. wherein specifying the projectId, mappingName are Mandatory in the Mapping Object.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mmMappingObjJson` - in JSON format
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Map is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMappingObjJson' for this:
      {
      "mappingName": "",
      "mappingDescription": "",
      "projectId": 0,
      "mappingSubStateName": "",
      "publishNotes": "",
      "subjectId": 0,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": null,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": "",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingId": -1,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": "",
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": "",
      "sourceExtractDescription": "",
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": "",
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 1,
      "effectiveDate": null
      }

    Since:
      6.2

  - ### createMappingAs

    public String createMappingAs(String mmMappingObjJson, boolean addSpecifications, String outputFormat)
    Creates Mapping for the specified mappingObject in the JSON and addSpecifications. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    If the value of addSpecifications is true, mapping gets created with all the specification details provided.If the value of addSpecifications is false only empty mapping with out any specifications gets created.
    Parameters:
      `mmMappingObjJson` - - JSON format
      `addSpecifications` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Map is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMappingObjJson' JSON :
      {
      "projectId": 0,
      "mappingName": "",
      "mappingId": 0,
      "mappingSubStateName": null,
      "publishNotes": null,
      "subjectId": -1,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 1,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 1,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ],
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": " ",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": null,
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": null,
      "sourceExtractDescription": "",
      "userDefined35": "",
      "mappingDescription": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": null,
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 0,
      "effectiveDate": null
      }

    Since:
      6.2

  - ### getMappingAs

    public String getMappingAs(int mappingId, String outputFormat)
    Returns Mapping Object for the specified mappingId in the specified outputFormat. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mappingId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Mapping object in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingAs

    public String getMappingAs(int mappingId, boolean fillSpecification, String outputFormat)
    Returns Mapping Object for the specified mappingId, fillSpecification in the JSON. outputFormat can be JSON or XML. If outputFormat is not specified, by default the method will return the JSON String. If fillSpecification is true, then the Mapping Object with mapping specifications is returned if false then Mapping Object without mapping specifications is returned.
    Parameters:
      `mappingId` - int
      `fillSpecification` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Mapping object in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingAs

    public String getMappingAs(int mappingId, boolean fillSpecification, boolean fillDocuments, String outputFormat)
    Returns Mapping Object for the specified mappingId, fillSpecifications, fillDocuments in the JSON. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the values of fillSpecifications and fillDocuments as true will return all the details pertaining to all the mappings in project, specifications and Document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `mappingId` - int
      `fillSpecification` - boolean
      `fillDocuments` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Mapping object in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingsInSubjectAs

    public String getMappingsInSubjectAs(String subjectName, boolean fillSpecifications, boolean fillDocuments, String outputFormat)
    Returns List of mappings for the specified subject Name, fillSpecifications, fillDocuments in the JSON. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the values of fillSpecifications and fillDocuments as true will return all the details pertaining to all the mappings of the subject, specifications and document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `subjectName` - String
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Mappings under subject in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingsInSubjectAs

    public String getMappingsInSubjectAs(int subjectId, boolean fillSpecifications, boolean fillDocuments, String outputFormat)
    Returns List of mappings for the specified subject Id, fillSpecifications, fillDocuments in the JSON. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the values of fillSpecifications and fillDocuments as true will return all the details pertaining to all the mappings in subject, specifications and Document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `subjectId` - int
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Mappings under subject in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingsInProjectAs

    public String getMappingsInProjectAs(int projectId, boolean fillSpecifications, boolean fillDocuments, String outputFormat)
    Returns List of Mappings for the specified projectId, fillSpecifications, fillDocuments in the JSON. Specification of projectId is mandatory.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the values of fillSpecifications and fillDocuments as true will return all the details pertaining to all the mappings, specifications and Document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `projectId` - int
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Mappings in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingsInProjectAs

    public String getMappingsInProjectAs(String projectName, boolean fillSpecifications, boolean fillDocuments, String outputFormat)
    Returns List of mappings for the specified project Name, fillSpecifications, fillDocuments. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the values of fillSpecifications and fillDocuments as true will return all the details pertaining to all the mappings, specifications and Document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `projectName` - String
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Mappings in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingIdAs

    public String getMappingIdAs(int parentNodeId, String nodeType, String mappingName, String outputFormat)
    Returns the mappingId for the specified parentNodeId, mappingName, nodeType in the JSON. Specification of parentNodeId, mappingName and nodeType are mandatory. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    The value of nodeType can be MM_SUBJECT or MM_PROJECT.Based on the nodeType, parentNodeId changes.
    If the nodeType is MM_SUBJECT, parentNodeId will be subjectId whereas if the nodeType is MM_PROJECT then parentNodeId will be projectId.
    Parameters:
      `parentNodeId` - int
      `mappingName` - String
      `nodeType` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - mappingId in JSON or XML
    Since:
      6.2

  - ### getMappingAs

    public String getMappingAs(int parentNodeId, String nodeType, String mappingName, String outputFormat)
    Returns Mapping Object for the specified parentNodeId, mappingName, nodeType in the JSON. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specification of parentNodeId, mappingName and nodeType is mandatory.NodeType can be either MM_PROJECT or MM_SUBJECT and parentNodeId can be Project Id, Subject Id depending on the nodeType.
    Parameters:
      `parentNodeId` - int
      `mappingName` - String
      `nodeType` - NodeType
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Mapping object in the form of JSON or XML String
    Since:
      6.2

  - ### getMappingDocumentsAs

    public String getMappingDocumentsAs(int mappingId, String outputFormat)
    Returns the List of Mapping Document objects for the specified mappingId. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specification of mappingId is mandatory, based on which it returns the list of all documents and their information present in that particular mapping.The filePath in the returned document object is RELATIVE.
    Parameters:
      `mappingId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Document objects in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingIdAs

    public String getMappingIdAs(String projectName, String mappingName, String outputFormat)
    Returns the mappingId for the specified mappingName and projectName in the JSON. Specifying mappingName and projectName are mandatory.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `projectName` - String
      `mappingName` - String
      `outputFormat` - Sting - Valid values: JSON or XML
    Returns:
      String - Mapping Id
    Since:
      6.2

  - ### getMappingsAs

    public String getMappingsAs(int parentNodeId, String nodeType, String outputFormat)
    Returns List of Mappings for the specified parentNodeId, nodeType. Specification of parentNodeId and nodeType are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    If the nodeType is MM_PROJECT parentNodeId will be projectId and if nodeType is MM_SUBJECT then parentNodeId will be subjectId.
    Parameters:
      `parentNodeId` - int
      `nodeType` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of mappings in the form of JSON or XML String.
    Since:
      6.2

  - ### updateMappingAs

    public String updateMappingAs(String mmMappingObjJson, String outputFormat)
    Updates mapping for the specified MappingObject in JSON . Specifying projectId and mapId are mandatory.
    All the specifications pertaining to mapping can be updated except the mappingName.The information which needs to be updated should be provided through mapping Object.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    If Mapping details are updated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `mmMappingObjJson` - in JSON format
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Map is updated successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMappingObjJson' JSON :
      {
      "mappingName": "",
      "mappingDescription": "",
      "projectId": 0,
      "mappingId": -1,
      "mappingSubStateName": "",
      "publishNotes": "",
      "subjectId": 0,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": null,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": "",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": "",
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": "",
      "sourceExtractDescription": "",
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": "",
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 1,
      "effectiveDate": null
      }

    Since:
      6.2

  - ### deleteMappingAs

    public String deleteMappingAs(int mappingId, String outputFormat)
    Deletes Mapping for the specified mappingId. mappingId is mandatory which has to be specified to delete a particular mapping. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mappingId` -
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Map is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### addMappingSpecificationsAs

    public String addMappingSpecificationsAs(int mapId, String mmMapSpecRowObjJsonArray, String outputFormat)
    Inserts List of mappingSpecifications into the specified mapId. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the mapId and List of mappingSpecifications is mandatory,all the mappingSpecifications will get inserted in to the particular mapId.
    Parameters:
      `mapId` - int
      `mmMapSpecRowObjJsonArray` - JSON String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping specification is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMapSpecRowObjJsonArray' JSON :
      [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 0,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 0,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ]

    Since:
      6.2

  - ### addMappingSpecificationAs

    public String addMappingSpecificationAs(int mapId, String mmMapSpecRowObjJson, String outputFormat)
    Inserts a single row of mappingSpecification for the specified mapId, mappingSpecificationRow. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapId` - int
      `mmMapSpecRowObjJson` - JSON
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping specification row is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMapSpecRowObjJson' for this:
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 0,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 0,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }

    Since:
      6.2

  - ### getMappingSpecificationsAs

    public String getMappingSpecificationsAs(int mappingId, String outputFormat)
    Returns the List of Mapping Specifications for the specified mappingId. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the mappingId is mandatory, based on which it returns all the individual maps present in that particular mapping.
    Parameters:
      `mappingId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of MappingSpecifications in the form of JSON or XML
    Since:
      6.2

  - ### deleteMappingSpecificationsAs

    public String deleteMappingSpecificationsAs(int mappingId, String outputFormat)
    Deletes all mappingSpecification rows for the specified mappingId. Specifying the maapingId is mandatory.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mappingId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping specification is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### deleteMappingSpecificationAs

    public String deleteMappingSpecificationAs(int mappingSequenceId, String outputFormat)
    Deletes mappingSpecification for the specified mappingSequenceId. Specifying the mappingSequenceId is mandatory.It deletes a particular mappingSpecification row of the mapping based on the mappingSequenceId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mappingSequenceId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping specification row is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### baselineProjectAs

    public String baselineProjectAs(int projectId, String versionLabel, String changeDescription, String outputFormat)
    Appends the baseline to the project for the specified projectId.
    Specifying the ProjectId , Version Label and Change Description are mandatory. Adds baseline to the project basing the type of versionLabel and specification of the changeDescription which is mandatory.
    outputFormat can be either Json or XML. If outputFormat is not specified, by default the method will return the Json String.
    Parameters:
      `projectId` - int
      `versionLabel` - String
      `changeDescription` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Project Baseline is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### versionMappingAs

    public String versionMappingAs(String mmMappingObjJson, String outputFormat)
    Appends version to the mapping for the specified MappingObject in JSON.
    Appends a new version to the mappings,specifying the changed description is mandatory along with the other details of Mapping Object.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mmMappingObjJson` - String - JSON
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Map Version is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMappingObjJson' JSON :
      {
      "mappingName": "",
      "mappingDescription": "",
      "changedDescription": "",
      "projectId": 0,
      "mappingId": -1,
      "mappingSubStateName": "",
      "publishNotes": "",
      "subjectId": 0,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": null,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": "",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": "",
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": "",
      "sourceExtractDescription": "",
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": "",
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 0,
      "effectiveDate": null
      }

    Since:
      6.2

  - ### getProjects

    public List<Project> getProjects(Node.Depth depth) throws Exception
    Returns the projects and its Details according to the specified Depth.
    Specifying the depth is mandatory. Depth has values NAMES, NAMES_IDS, DETAILS, DETAILS_DOCUMENTS, DETAILS_PROJECT_RESOURCES, ALL.
    NAMES - Returns the names of the Projects.
    NAMES_IDS - Returns the names and projectIds.
    DETAILS - Returns the projectDetails.
    DETAILS_DOCUMENTS - Returns the projectDetails and projectDocuments.
    DETAILS_PROJECT_RESOURCES - Returns the projectDetails and projectResources.
    ALL - Returns the projectDetails, projectDocuments and projectResources.
    Parameters:
      `depth` - Node Object - valid depth types are NAMES, NAMES_IDS, DETAILS, DETAILS_DOCUMENTS, DETAILS_PROJECT_RESOURCES, ALL.
    Returns:
      List of project Objects.
    Throws:
      `Exception`

  - ### uploadMapping

    public RequestStatus uploadMapping(int mapId, MappingImportHelper mappingImportHelper)
    Uploads the mappingSpecifications on the specified mapId of importFileType, importType specified in MappingImportHelper Object.
    Specifying the mapId, importFileType, importType,filePath and filePathType are mandatory.
    The supported values for the filePathType are ABSOLUTE, RELATIVE.
    Valid importFileType is only MAPPINGMANAGER_EXCEL and importType can be APPEND_TO_EXISTING or DELETE_AND_RELOAD.
    Parameters:
      `mapId` - int
      `mappingImportHelper` - MappingImportHelper Object
    Returns:
      RequestStatus Object

  - ### uploadMapping

    public RequestStatus uploadMapping(int nodeId, Node.NodeType nodeType, MappingImportHelper mappingImportHelper)
    Uploads the mappingSpecifications on the specified nodeId, nodeType of importFileType, importType specified in MappingImportHelper Object.
    Specifying the nodeId, nodeType, importFileType, importType, filePath and filePathType are mandatory.
    Valid importFileTypes are MAPPINGMANAGER_LEGACY_EXCEL, MAPPINGMANAGER_XML, INFORMATICA, DATASTAGE, SSIS_2008 and importType can be APPEND_TO_EXISTING or DELETE_AND_RELOAD.
    The supported values for the filePathType are ABSOLUTE, RELATIVE.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT.
      `mappingImportHelper` - MappingImportHelper oBJECT.
    Returns:
      RequestStatus Object

  - ### exportAll

    public RequestStatus exportAll(int nodeId, Node.NodeType nodeType, APIConstants.SelectionCriteria selectionCriteria, APIConstants.ExportOption exportOption, boolean includePseudoCode, boolean visibleColumns)
    Mapping Specifications are exported to excel for the specified nodeId. nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    All the mappings of the specified projectId or SubjectId are exported to excel. The exported filePath will be available in the userObject of requestStatus object and and the filePath will be RELATIVE. Specifying nodeId, nodeType and exportOption are Mandatory.
    selectionCriteria has values ALL, ACTIVE or PASSIVE, By default selectionCriteria takes the value ACTIVE.
    If selectionCriteria value is ALL it exports both ACTIVE and PASSIVE mappings.
    If selectionCriteria value is ACTIVE it exports only ACTIVE mappings.
    If selectionCriteria value is PASSIVE it exports only PASSIVE mappings.
    exportOption has values ExportintMultipleSheet, ExportAll or ExportintoSingleSheet.
    If exportOption value is ExportintMultipleSheet it refers to exporting to single workbook with multiple excelSheets..
    If exportOption value is ExportAll it refers to exporting to individual excel Files.
    If exportOption value is ExportintoSingleSheet it refers to exporting to a single excel Sheet.
    Visible columns has a value either true or false.
    If the Visible Columns is True, only the visible columns of mapping specification grid are exported.
    If the Visible Columns is False, then all the columns both visible and hidden from Mapping specification grid are exported to excel.
    If the value of Visible Columns is not specified, by default it takes the value False.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid types are MM_PROJECT, MM_SUBJECT
      `selectionCriteria` - String - valid types are ALL, ACTIVE, PASSIVE.
      `exportOption` - String - valid Types are ExportintMultipleSheet, ExportAll, ExportintoSingleSheet.
      `includePseudoCode` - Boolean
      `visibleColumns` - Boolean
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### exportMappingToExcel

    public RequestStatus exportMappingToExcel(int mapId, boolean visibleColumns, boolean includePseudocode)
    Mapping Specification is exported to excel for the specified mapId. Specifying the mapId is mandatory.
    i.e all the mapping specification details such as target details and source details are exported to excel. The exported filePath will be available in the userObject of requestStatus object and and the filePath will be RELATIVE.
    Visible columns has a value either true or false.
    If the Visible Columns is True, only the visible columns of mapping specification grid are exported.
    If the Visible Columns is False, then all the columns both visible and hidden from Mapping specification grid are exported to excel.
    If the value of Visible Columns is not specified, by default it takes the value False.
    Parameters:
      `mapId` - int
      `visibleColumns` - boolean
      `includePseudocode` - boolean
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### exportMappingToExcel

    public RequestStatus exportMappingToExcel(int nodeId, Node.NodeType nodeType, String mapName, boolean visibleColumns, boolean includePseudocode)
    Mapping Specification is exported to excel for the specified mapName. Specifying the mapName,nodeType, nodeId are mandatory.
    i.e all the mapping specification details such as target details and source details are exported to excel. The exported filePath will be available in the userObject of requestStatus object and and the filePath will be RELATIVE.
    Visible columns has a value either true or false.
    If the Visible Columns is True, only the visible columns of mapping specification grid are exported.
    If the Visible Columns is False, then all the columns both visible and hidden from Mapping specification grid are exported to excel.
    If the value of Visible Columns is not specified, by default it takes the value False.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `visibleColumns` - boolean
      `includePseudocode` - boolean
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### exportMappingXml

    public RequestStatus exportMappingXml(int nodeId, Node.NodeType nodeType, APIConstants.SelectionCriteria selectionCriteria)
    Mapping Specifications are exported to XML for the specified nodeId. Specifying the nodeId, nodeType are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    All the mappings of the specified projectId or SubjectId are exported to XML. The exported filePath will be available in the userObject of requestStatus object and and the filePath will be RELATIVE.
    selectionCriteria has values ALL, ACTIVE or PASSIVE, By default selectionCriteria takes the value ACTIVE.
    If selectionCriteria value is ALL it exports both ACTIVE and PASSIVE mappings.
    If selectionCriteria value is ACTIVE it exports only ACTIVE mappings.
    If selectionCriteria value is PASSIVE it exports only PASSIVE mappings.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `selectionCriteria` - String - APIConstants Object valid types are ALL, ACTIVE, PASSIVE.
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### getMapping

    public Mapping getMapping(int nodeId, Node.NodeType nodeType, String mapName, float versionNo) throws Exception
    Returns all the information relating to the specified mapName, such as mappingDescription, mappingSpecVersion, mappingStatus,
    mappingPlannedDevelopmentEffort, actualEffort,testingNotes, versionLabel, userDefined Fields, AuditFields etc...
    Specifying the mapName, nodeId, nodeType, versionNo are mandatory.
    nodeType can be MM_PROJECT, MM_SUBJECT.Depending upon the nodeType, nodeId would be either projectId or subjectId.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `versionNo` - float
    Returns:
      Mapping Object
    Throws:
      `Exception`
    Since:
      7.0

  - ### getMappings

    public ArrayList<Mapping> getMappings(List<Integer> mapIds, boolean fillSpecifications, boolean fillDocuments) throws Exception
    Returns List of Mappings for the specified List of mapIds. fillSpecifications and fillDocuments has values true or false. Specifying mapIds is mandatory.
    If fillSpecifications and fillDocuments has value true, it returns the list of mappings along with mapping specification details and Documents associated with those mappings.
    If fillSpecifications and fillDocuments has value false, it returns the list of mappings and details associated with those mappings. In this it does not return mapping specification details and Documents associated with those mappings.
    Parameters:
      `mapIds` - List
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
    Returns:
      ArrayList
    Throws:
      `Exception`
    Since:
      7.0

  - ### cloneMapping

    public RequestStatus cloneMapping(int srcMapId, boolean createNewVersion, String newMapName, int tgtNodeId, Node.NodeType tgtnodeType)
    Clone Mapping creates another copy of the map. i.e it copies the map specified at srcMapId and creates another copy at the specified tgtNodeId.
    Specifying srcMapId, tgtnodeType, tgtNodeId are mandatory. createNewVersion has the values as true or false.
    If createNewVersion has value False, then specifying newMapName is mandatory.
    Target nodeType can be MM_PROJECT, MM_SUBJECT, MM_MAPPING. Depending upon the tgtnodeType, tgtNodeId would be either projectId, subjectId or mapId.
    Parameters:
      `srcMapId` - int
      `createNewVersion` - boolean
      `newMapName` - String
      `tgtNodeId` - int
      `tgtnodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### cloneMapping

    public RequestStatus cloneMapping(int srcNodeId, Node.NodeType srcnodeType, String srcMapName, boolean createNewVersion, String newMapName, int tgtNodeId, Node.NodeType tgtnodeType)
    Clone Mapping creates another copy of the map. i.e it copies the map specified at srcNodeId with srcMapName and creates another copy at the specified tgtNodeId.
    Specifying srcMapName, tgtnodeType, tgtNodeId are mandatory. createNewVersion has the values as true or false.
    If createNewVersion has value False, then specifying newMapName is mandatory. nodeType can be MM_PROJECT, MM_SUBJECT.Depending upon the nodeType ,nodeId would be either projectId, subjectId or mapId.
    Parameters:
      `srcNodeId` - int
      `srcnodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `srcMapName` - String
      `createNewVersion` - boolean
      `newMapName` - String
      `tgtNodeId` - int
      `tgtnodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### mergeMapping

    public RequestStatus mergeMapping(int srcNodeId, Node.NodeType srcNodeType, String srcMapName, int tgtNodeId, Node.NodeType tgtNodeType, String tgtMapName, boolean createNewVersion, String changeDescription)
    Merge Mapping combines the mapping specifications of one map in to the other map.I.e it copies the map specified at srcNodeId with srcMapName and merges with the map specified at tgtNodeId with the name tgtMapName.
    Specifying the srcNodeId, tgtNodeId, srcMapName, tgtMapName are Mandatory.
    createNewVersion has value as either true or false. If createNewVersion has value true, it creates a new version at tgtNodeId, otherwise it overwrites the mapping. Specifying the change description is mandatory.
    nodeType can be MM_PROJECT, MM_SUBJECT, MM_MAPPING.Depending upon the nodeType ,nodeId would be either projectId, subjectId or mapId.
    Parameters:
      `srcNodeId` - int
      `srcNodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `srcMapName` - String
      `tgtNodeId` - int
      `tgtNodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `tgtMapName` - String
      `createNewVersion` - Boolean
      `changeDescription` - String
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### mergeMapping

    public RequestStatus mergeMapping(int srcMapId, int tgtMapId, boolean createNewVersion, String changeDescription)
    Merge Mapping combines the mapping specifications of one map in to the other map.I.e it copies the map specified at srcMapId and merges with the map specified at tgtMapId.Specifying srcMapId and tgtMapId are mandatory.
    createNewVersion has value as either true or false. If createNewVersion has value true, it creates a new version at tgtMapId, otherwise it overwrites the mapping. Specifying the change description is mandatory.
    Parameters:
      `srcMapId` - int
      `tgtMapId` - int
      `createNewVersion` - Boolean
      `changeDescription` - String
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### moveMapping

    public RequestStatus moveMapping(int srcMapId, int tgtNodeId, Node.NodeType tgtnodeType, boolean replaceIfExists, String newMapName)
    Move Mapping moves the map from srcMapId to the specified tgtNodeId. Specifying the srcMapId, tgtNodeId are mandatory.
    replaceIfExists has values true or false.If replaceIfExists has value False, it moves the mapping with the newMapName to tgtNodeId.
    nodeType can be MM_PROJECT, MM_SUBJECT.Depending upon the nodeType ,nodeId would be either projectId or subjectId.
    Parameters:
      `srcMapId` - int
      `tgtNodeId` - int
      `tgtnodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `replaceIfExists` - boolean
      `newMapName` - String
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### moveMapping

    public RequestStatus moveMapping(int srcNodeId, Node.NodeType srcNodeType, String srcMapName, int tgtNodeId, Node.NodeType tgtnodeType, boolean replaceIfExists, String newMapName)
    Move Mapping moves the map from srcNodeId to the specified tgtNodeId. Specifying the srcNodeId, srcNodeType, tgtNodeId, tgtnodeType are mandatory.
    replaceIfExists has values true or false.If replaceIfExists has value False, it moves the mapping with the newMapName to tgtNodeId.
    nodeType can be MM_PROJECT, MM_SUBJECT.Depending upon the nodeType ,nodeId would be either projectId or subjectId .
    Parameters:
      `srcNodeId` - int
      `srcNodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `srcMapName` - String
      `tgtNodeId` - int
      `tgtnodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `replaceIfExists` - boolean
      `newMapName` - String
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### publishMapping

    public RequestStatus publishMapping(int mapId, Date effectiveDate, String changeDescription, String publishNotes)
    Mapping is published for the specified mapId. specifying the mapId, effectiveDate, changeDescription, publishNotes are mandatory.
    Parameters:
      `mapId` - int
      `effectiveDate` - Date
      `changeDescription` - String
      `publishNotes` - String
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### publishMapping

    public RequestStatus publishMapping(int nodeId, Node.NodeType nodeType, String mapName, Date effectiveDate, String changeDescription, String publishNotes)
    Mapping is published for the specified mapName.specifying the mapName, effectiveDate, changeDescription, publishNotes are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `effectiveDate` - Date
      `changeDescription` - String
      `publishNotes` - String
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### unPublishMap

    public RequestStatus unPublishMap(int mapId)
    Mapping is unpublished for the specified mapId. Specifying the mapId is mandatory.
    Once the map is unpublished, it will be removed from published mappings workspace and the map will be a normal map in projects Tree.
    Parameters:
      `mapId` - int
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### unPublishMap

    public RequestStatus unPublishMap(int nodeId, Node.NodeType nodeType, String mapName, float versionNo)
    Mapping is unpublished for the specified nodeId.Specifying the nodeId, nodeType are mandatory. Incase when a particular map is published many times, it creates multiple versions.
    In that case, to delete a particular version, specifying mapName and versionNo are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `versionNo` - float
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### setMappingLock

    public RequestStatus setMappingLock(int mapId, boolean lockStatus)
    mappingLock can be either set to lock or unlock i.e to either true or false for the specified mapId. specifying the mapId, lockStatus are mandatory.
    Parameters:
      `mapId` - int
      `lockStatus` - boolean
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### setMappingLock

    public RequestStatus setMappingLock(int nodeId, Node.NodeType nodeType, String mapName, boolean lockStatus)
    mappingLock can be either set to lock or unlock i.e to either true or false for the specified mapName. specifying the mapName, nodeId, nodeType are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `lockStatus` - boolean
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### getMappingSpecifications

    public List<MappingSpecificationRow> getMappingSpecifications(List<Integer> mappingSequenceIds) throws Exception
    Returns the List of MappingSpecification Rows for the specified List of mapSequenceIds.
    Mapping Specifications includes all source details and target details.Specifying the mapSequenceIds are mandatory.
    Parameters:
      `mappingSequenceIds` - List
    Returns:
      List - MappingSpecificationRow
    Throws:
      `Exception`
    Since:
      7.0

  - ### updateMappingSpecification

    public RequestStatus updateMappingSpecification(MappingSpecificationRow mappingSpecificationRow)
    Mapping Specification is updated as the specified mappingSpecificationRow. Specifying mappingId, mappingSequenceId are modified.
    Parameters:
      `mappingSpecificationRow` - MappingSpecificationRow Object
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### updateMappingSpecifications

    public RequestStatus updateMappingSpecifications(List<MappingSpecificationRow> mappingSpecificationRows)
    Mapping Specifications are updated as specified in List of mappingSpecificationRows. Specifying mappingIds, mappingSequenceIds are modified.
    Parameters:
      `mappingSpecificationRows` - List
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### deleteMappingSpecifications

    public RequestStatus deleteMappingSpecifications(List<Integer> mappingSequenceIds)
    Deletes the mappingSpecifications for the specified List of mappingSequenceIds.Specifying the mappingSequenceIds are mandatory.
    Parameters:
      `mappingSequenceIds` - List
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### deleteMappingSpecificationRow

    public RequestStatus deleteMappingSpecificationRow(MappingSpecificationRow mappingSpecificationRow)
    Deletes the mappingSpecification for the specified mappingSpecificationRow Object.
    Specifying the mappingSequenceId are mandatory.
    Parameters:
      `mappingSpecificationRow` - Object
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### deleteMappingSpecificationRows

    public RequestStatus deleteMappingSpecificationRows(List<MappingSpecificationRow> mappingSpecificationRows)
    Deletes the mappingSpecifications for the specified List of mappingSpecificationRows.
    Specifying the mappingSequenceIds are mandatory.
    Parameters:
      `mappingSpecificationRows` - Object
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### deleteMapping

    public RequestStatus deleteMapping(int mapId, APIConstants.VersionMode versionMode, float versionNo)
    Deletes the mapping of the specified mapId, versionMode. Specifying the mapId, versionMode are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
    ALL_VERSIONS - Deletes all mappings.
    CURRENT_VERSION - Deletes the present/current version.
    SPECIFIC_VERSION - Deletes a particular version.
    If the versionMode is SPECIFIC_VERSION , specifying the versionNo is mandatory.
    Parameters:
      `mapId` - int
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` - Float
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### deleteMappings

    public RequestStatus deleteMappings(List<Integer> mappingIds, APIConstants.VersionMode versionMode, float versionNo)
    Deletes the mappings of the specified mappingIds. Specifying the mappingIds, versionMode are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION. ALL_VERSIONS - Deletes all mappings, CURRENT_VERSION - Deletes the present/current version, SPECIFIC_VERSION - Deletes a particular version.
    Parameters:
      `mappingIds` - List - should be active
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` - float
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### deleteMapping

    public RequestStatus deleteMapping(int nodeId, Node.NodeType nodeType, String mapName, APIConstants.VersionMode versionMode, float versionNo)
    Deletes the map for the specified mapName of the given nodeType and nodeId. specifying the mapName, nodeType, nodeId are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION. ALL_VERSIONS - Deletes all mappings, CURRENT_VERSION - Deletes the present/current version. SPECIFIC_VERSION - Deletes a particular version.
    If the versionMode is SPECIFIC_VERSION , specifying the versionNo is mandatory.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` - Float
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### deleteMappings

    public RequestStatus deleteMappings(int nodeId, Node.NodeType nodeType, List<String> mapNames, APIConstants.VersionMode versionMode, float versionNo)
    Deletes the mappings of the specified List of mapNames of the given nodeType and nodeId. Specifying the mapNames, nodeType, nodeId, versionMode are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION. ALL_VERSIONS - Deletes all mappings, CURRENT_VERSION - Deletes the present/current version, SPECIFIC_VERSION - Deletes a particular version.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
      `mapNames` - List
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` - float
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### deleteMappings

    public RequestStatus deleteMappings(int nodeId, Node.NodeType nodeType, APIConstants.VersionMode versionMode, float versionNo)
    Deletes the mappings of the given nodeType and nodeId. specifying the nodeType, nodeId are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION. ALL_VERSIONS - Deletes all mappings, CURRENT_VERSION - Deletes the present/current version, SPECIFIC_VERSION - Deletes a particular version.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `versionMode` - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` -
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### addMappingDocument

    public RequestStatus addMappingDocument(int mapId, Document document)
    MappingDocument is added for the specified mapId. specifying the mapId, documentName, documentObject and filePathType are mandatory in the document object. The supported values for the filePathType are ABSOLUTE, RELATIVE.
    Parameters:
      `mapId` - int
      `document` - Document
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### addMappingDocument

    public RequestStatus addMappingDocument(int nodeId, Node.NodeType nodeType, String mapName, Document document)
    MappingDocument is added for the specified mapName. specifying the mapName, documentName, documentObject and filePathType are mandatory. The supported values for the filePathType are ABSOLUTE, RELATIVE.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    Parameters:
      `nodeId` - int
      `nodeType` - Node Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `document` - Document
    Returns:
      RequestStatus Object
    Since:
      7.0

  - ### exportMappingToExcelAs

    public String exportMappingToExcelAs(int mapId, boolean visibleColumns, boolean includePseudocode, String outputFormat)
    Mapping Specification is exported to excel for the specified mapId.Specifying the mapId is mandatory.
    i.e all the mapping specification details such as target details and source details are exported to excel. The exported filePath will be available in the userObject of requestStatus object and and the filePath will be RELATIVE.
    Visible columns has a value either true or false.
    If the Visible Columns is True only the visible columns of mapping specification grid are exported.
    If the Visible Columns is False, then all the columns both visible and hidden from Mapping specification grid are exported to excel.
    If the value of Visible Columns is not specified, by default it takes the value False.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapId` - int
      `visibleColumns` - boolean
      `includePseudocode` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If exportMappingToExcelAs is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### exportMappingToExcelAs

    public String exportMappingToExcelAs(int nodeId, String nodeType, String mapName, boolean visibleColumns, boolean includePseudocode, String outputFormat)
    Mapping Specification is exported to excel for the specified mapName. Specifying the mapName,nodeType, nodeId are mandatory.
    i.e all the mapping specification details such as target details and source details are exported to excel. The exported filePath will be available in the userObject of requestStatus object and and the filePath will be RELATIVE.
    Visible columns has a value either true or false.
    If the Visible Columns is True only the visible columns of mapping specification grid are exported.
    If the Visible Columns is False, then all the columns both visible and hidden from Mapping specification grid are exported to excel.
    If the value of Visible Columns is not specified, by default it takes the value False.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `visibleColumns` - boolean
      `includePseudocode` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If exportMappingToExcelAs is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### exportAllAs

    public String exportAllAs(int nodeId, String nodeType, String selectionCriteria, String exportOption, boolean includePseudoCode, boolean visibleColumns, String outputFormat)
    Mapping Specifications are exported to excel for the specified nodeId. nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    All the mappings of the specified projectId or SubjectId are exported to excel. The exported filePath will be available in the userObject of requestStatus object and and the filePath will be RELATIVE. Specifying nodeId, nodeType and exportOption are Mandatory.
    selectionCriteria has values ALL, ACTIVE or PASSIVE, By default selectionCriteria takes the value ACTIVE.
    If selectionCriteria value is ALL it exports both ACTIVE and PASSIVE mappings.
    If selectionCriteria value is ACTIVE it exports only ACTIVE mappings.
    If selectionCriteria value is PASSIVE it exports only PASSIVE mappings.
    exportOption has values ExportintMultipleSheet, ExportAll or ExportintoSingleSheet.
    If exportOption value is ExportintMultipleSheet it refers to exporting to single workbook with multiple excelSheets..
    If exportOption value is ExportAll it refers to exporting to individual excel Files.
    If exportOption value is ExportintoSingleSheet it refers to exporting to a single excel Sheet.
    Visible columns has a value either true or false.
    If the Visible Columns is True only the visible columns of mapping specification grid are exported.
    If the Visible Columns is False, then all the columns both visible and hidden from Mapping specification grid are exported to excel.
    If the value of Visible Columns is not specified, by default it takes the value False.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `selectionCriteria` - String - valid types are ALL, ACTIVE, PASSIVE.
      `exportOption` - String - valid types are ExportintMultipleSheet, ExportAll, ExportintoSingleSheet.
      `includePseudoCode` - Boolean
      `visibleColumns` - Boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If exportAllAs is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### exportMappingXmlAs

    public String exportMappingXmlAs(int nodeId, String nodeType, String selectionCriteria, String outputFormat)
    Mapping Specifications are exported to XML for the specified nodeId. Specifying the nodeId, nodeType are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    All the mappings of the specified projectId or SubjectId are exported to XML. The exported filePath will be available in the userObject of requestStatus object and and the filePath will be RELATIVE.
    selectionCriteria has values ALL, ACTIVE or PASSIVE, By default selectionCriteria takes the value ACTIVE.
    If selectionCriteria value is ALL it exports both ACTIVE and PASSIVE mappings.
    If selectionCriteria value is ACTIVE it exports only ACTIVE mappings.
    If selectionCriteria value is PASSIVE it exports only PASSIVE mappings.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `selectionCriteria` - String - APIConstants Object valid types are ALL, ACTIVE, PASSIVE.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If exportMappingXmlAs is successful,it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### getMappingAs

    public String getMappingAs(int nodeId, String nodeType, String mapName, float versionNo, String outputFormat)
    Returns all the information relating to the specified mapName, such as mappingDescription, mappingSpecVersion, mappingStatus,
    mappingPlannedDevelopmentEffort, actualEffort,testingNotes, versionLabel, userDefined Fields, AuditFields etc...
    Specifying the mapName, nodeId, nodeTyp and versionNo are mandatory.
    nodeType can be MM_PROJECT, MM_SUBJECT.Depending upon the nodeType, nodeId would be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `versionNo` - float
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping object is returned successfully, it returns success message otherwise returns failure message.
    Since:
      7.0

  - ### getMappingsAs

    public String getMappingsAs(String MapIdsJsonArray, boolean fillSpecifications, boolean fillDocuments, String outputFormat)
    Returns List of Mappings for the specified List of mapIds. fillSpecifications and fillDocuments have values true or false. Specifying the mapIds is mandatory.
    If fillSpecifications and fillDocuments have value true, it returns the list of mappings along with mapping specification details and Documents associated with those mappings.
    If fillSpecifications and fillDocuments have value false, it returns the list of mappings and details associated with those mappings. In this it does not return mapping specification details and Documents associated with those mappings.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `MapIdsJsonArray` - String - List
      `fillSpecifications` - Boolean
      `fillDocuments` - Boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mappings are returned successfully, it returns success message otherwise returns failure message.
    Since:
      7.0

  - ### cloneMappingAs

    public String cloneMappingAs(int srcMapId, boolean createNewVersion, String newMapName, int tgtNodeId, String tgtnodeType, String outputFormat)
    Clone Mapping creates another copy of the map. i.e it copies the map specified as srcMapId and creates another copy at the specified tgtNodeId.
    Specifying srcMapId, tgtnodeType, tgtNodeId are mandatory. createNewVersion has the values as true or false.
    If createNewVersion has value True, then specifying newMapName is mandatory.
    nodeType can be MM_PROJECT, MM_SUBJECT.Depending upon the nodeType ,nodeId would be either projectId, subjectId or mapId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `srcMapId` - int
      `createNewVersion` - Boolean
      `newMapName` - String
      `tgtNodeId` - int
      `tgtnodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Clone Mapping is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### cloneMappingAs

    public String cloneMappingAs(int srcNodeId, String srcnodeType, String srcMapName, boolean createNewVersion, String newMapName, int tgtNodeId, String tgtnodeType, String outputFormat)
    Clone Mapping creates another copy of the map. i.e it copies the map specified at srcNodeId with srcMapName and creates another copy at the specified tgtNodeId.
    Specifying srcMapName, tgtnodeType, tgtNodeId are mandatory. createNewVersion has the values as true or false.
    If createNewVersion has value True, then specifying newMapName is mandatory. nodeType can be MM_PROJECT, MM_SUBJECT. Depending upon the nodeType ,nodeId would be either projectId, subjectId or mapId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `srcNodeId` - int
      `srcnodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `srcMapName` - String
      `createNewVersion` - Boolean
      `newMapName` - String
      `tgtNodeId` - int
      `tgtnodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Clone Mapping is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### mergeMappingAs

    public String mergeMappingAs(int srcMapId, int tgtMapId, boolean createNewVersion, String changeDescription, String outputFormat)
    Merge Mapping combines the mapping specifications of one map in to the other map.I.e it copies the map specified at srcMapId and merges with the map specified at tgtMapId.Specifying srcMapId and tgtMapId are mandatory.
    createNewVersion has value as either true or false. If createNewVersion has value true, it creates a new version at tgtMapId, otherwise it overwrites the mapping. Specifying the change description is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `srcMapId` - int
      `tgtMapId` - int
      `createNewVersion` - Boolean
      `changeDescription` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Merge Mapping is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### mergeMappingAs

    public String mergeMappingAs(int srcNodeId, String srcNodeType, String srcMapName, int tgtNodeId, String tgtNodeType, String tgtMapName, boolean createNewVersion, String changeDescription, String outputFormat)
    Merge Mapping combines the mapping specifications of one map in to the other map.I.e it copies the map specified at srcNodeId with srcMapName and merges with the map specified at tgtNodeId with the name tgtMapName.
    Specifying the srcNodeId, tgtNodeId, srcMapName, tgtMapName are Mandatory.
    createNewVersion has value as either true or false. If createNewVersion has value true, it creates a new version at tgtNodeId, otherwise it overwrites the mapping. Specifying the change description is mandatory.
    nodeType can be MM_PROJECT, MM_SUBJECT, MM_MAPPING.Depending upon the nodeType ,nodeId would be either projectId, subjectId or mapId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `srcNodeId` - int
      `srcNodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `srcMapName` - String
      `tgtNodeId` - int
      `tgtNodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `tgtMapName` - String
      `createNewVersion` - Boolean
      `changeDescription` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Merge Mapping is done successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### moveMappingAs

    public String moveMappingAs(int srcMapId, int tgtNodeId, String tgtnodeType, boolean replaceIfExists, String newMapName, String outputFormat)
    Move Mapping moves the map from srcMapId to the specified tgtNodeId. Specifying the srcMapId, tgtNodeId are mandatory.
    replaceIfExists has values true or false.If replaceIfExists has value false, it moves the mapping with the newMapName to tgtNodeId.
    nodeType can be MM_PROJECT, MM_SUBJECT.Depending upon the nodeType ,nodeId would be either projectId or subjectId .
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `srcMapId` - int
      `tgtnodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `tgtNodeId` - int
      `replaceIfExists` - boolean
      `newMapName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If moveMappingAs is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### moveMappingAs

    public String moveMappingAs(int srcNodeId, String srcNodeType, String srcMapName, int tgtNodeId, String tgtnodeType, boolean replaceIfExists, String newMapName, String outputFormat) throws com.icc.exceptions.DaoException
    Move Mapping moves the map from srcNodeId to the specified tgtNodeId. Specifying the srcNodeId, srcNodeType, tgtnodeType, tgtNodeId are mandatory.
    replaceIfExists has values true or false.If replaceIfExists has value False, it moves the mapping with the newMapName to tgtNodeId.
    nodeType can be MM_PROJECT, MM_SUBJECT.Depending upon the nodeType ,nodeId would be either projectId or subjectId .
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `srcNodeId` - int
      `srcNodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `srcMapName` - String
      `tgtNodeId` - int
      `tgtnodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `replaceIfExists` - Boolean
      `newMapName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If moveMappingAs is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Throws:
      `com.icc.exceptions.DaoException`
    Since:
      7.0

  - ### publishMappingAs

    public String publishMappingAs(int mapId, Date effectiveDate, String changeDescription, String publishNotes, String outputFormat)
    Mapping is published for the specified mapId.specifying the mapId, effectiveDate, changeDescription, publishNotes are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapId` - int
      `effectiveDate` - Date
      `changeDescription` - String
      `publishNotes` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If publish Mapping is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### publishMappingAs

    public String publishMappingAs(int nodeId, String nodeType, String mapName, Date effectiveDate, String changeDescription, String publishNotes, String outputFormat)
    Mapping is published for the specified mapName.specifying the mapName, effectiveDate, changeDescription, publishNotes are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `effectiveDate` - Date
      `changeDescription` - String
      `publishNotes` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If publish Mapping is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### unPublishMapAs

    public String unPublishMapAs(int mapId, String outputFormat)
    Mapping is unpublished for the specified mapId.Specifying the mapId is mandatory.
    Once the map is unpublished, it will be removed from published mappings workspace and the map will be a normal map in projects Tree. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping is unPublished successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### unPublishMapAs

    public String unPublishMapAs(int nodeId, String nodeType, String mapName, float versionNo, String outputFormat)
    Mapping is unpublished for the specified nodeId.Specifying the nodeId, nodeType are mandatory. Incase when a particular map is published many times, it creates multiple versions.
    In that case, to delete a particular version, specifying mapName and versionNo are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `nodeId` - int
      `mapName` - String
      `versionNo` - float
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping is unPublished successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### setMappingLockAs

    public String setMappingLockAs(int mapId, boolean lockStatus, String outputFormat)
    mappingLock can be either set to lock or unlock for the specified mapId. specifying the mapId, lockStatus are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapId` - int
      `lockStatus` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If MappingLock is set successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### setMappingLockAs

    public String setMappingLockAs(int nodeId, String nodeType, String mapName, boolean lockStatus, String outputFormat)
    mappingLock can be either set to lock or unlock for the specified mapName. specifying the mapName, nodeId, nodeType are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `lockStatus` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If MappingLock is set successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### getMappingSpecificationsAs

    public String getMappingSpecificationsAs(String mapSeqIdsJsonArray, String outputFormat)
    Returns the List of MappingSpecification Rows for the specified List of mapSequenceIds.
    Mapping Specifications includes all source details and target details. Specifying the mapSequenceIds are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapSeqIdsJsonArray` - String - List of Ids
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If MappingSpecifications are returned successfully, it returns success message otherwise returns failure message.
    Since:
      7.0

  - ### updateMappingSpecificationAs

    public String updateMappingSpecificationAs(String mappingSpecificationRowJsonObj, String outputFormat)
    Mapping Specification is updated with the specified mappingSpecificationRow object. Specifying mappingId, mappingSequenceId are modified.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mappingSpecificationRowJsonObj` - String - mappingSpecificationRow Object
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If MappingSpecification is updated successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingSpecificationRowObjJson' JSON :
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 0,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 0,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }

    Since:
      7.0

  - ### updateMappingSpecificationsAs

    public String updateMappingSpecificationsAs(String mappingSpecificationRowJsonArray, String outputFormat)
    Mapping Specifications are updated as specified in List of mappingSpecificationRows.Specifying mappingIds, mappingSequenceIds are modified.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mappingSpecificationRowJsonArray` - String - mappingSpecificationRow Object
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If MappingSpecifications are updated successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingSpecificationRowJsonArray' JSON :
      [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 0,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 0,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      },
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 0,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 0,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ]

    Since:
      7.0

  - ### deleteMappingSpecificationsAs

    public String deleteMappingSpecificationsAs(String mapSeqIdsJsonArray, String outputFormat)
    Deletes the mappingSpecifications for the specified List of mapSequenceIds. Specifying the mappingSequenceIds is mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapSeqIdsJsonArray` - String - List of Ids.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If MappingSpecifications are deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### deleteMappingsAs

    public String deleteMappingsAs(String mappingIdsJsonArray, String versionMode, float versionNo, String outputFormat)
    Deletes the mappings for the specified mappingIds. Specifying the mappingIds is mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION. ALL_VERSIONS - Deletes all mappings, CURRENT_VERSION - Deletes the present/current version, SPECIFIC_VERSION - Deletes a particular version.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mappingIdsJsonArray` - String - List of mappingIds
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` - float
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mappings are deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### deleteMappingAs

    public String deleteMappingAs(int nodeId, String nodeType, String mapName, String versionMode, float versionNo, String outputFormat)
    Deletes the map for the specified mapName of the given nodeType and nodeId. specifying the mapName, nodeType, nodeId are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION. ALL_VERSIONS - Deletes all mappings, CURRENT_VERSION - Deletes the present/current version. SPECIFIC_VERSION - Deletes a particular version.
    If the versionMode is SPECIFIC_VERSION , specifying the versionNo is mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` - Float
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### deleteMappingsAs

    public String deleteMappingsAs(int nodeId, String nodeType, String versionMode, float versionNo, String outputFormat)
    Deletes the mappings of the given nodeType and nodeId. specifying the nodeType, nodeId are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION. ALL_VERSIONS - Deletes all mappings, CURRENT_VERSION - Deletes the present/current version. SPECIFIC_VERSION - Deletes a particular version.
    If the versionMode is SPECIFIC_VERSION , specifying the versionNo is mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` -
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mappings are deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### addMappingDocumentAs

    public String addMappingDocumentAs(int mapId, String document, String outputFormat)
    MappingDocument is added for the specified mapId. specifying the mapId, documentName and either of documentObject or documentLink and filePathType are mandatory. The supported values for the filePathType are ABSOLUTE, RELATIVE.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapId` - int
      `document` - String - Document
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping Document is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'document' JSON :
      {
      "documentIntendedPurpose": "",
      "userData": null,
      "documentReferenceNumber": "",
      "documentType": "",
      "documentName": "",
      "documentApprovedBy": "",
      "documentObject": "",
      "approvalRequired": false,
      "documentOwner": "",
      "documentLink": "",
      "filePathType" : "", "documentId": 0,
      "documentReference": "",
      "documentStatus": "",
      "documentApprovedDate": 1460701213000
      }

    Since:
      7.0

  - ### addMappingDocumentAs

    public String addMappingDocumentAs(int nodeId, String nodeType, String mapName, String document, String outputFormat)
    MappingDocument is added for the specified mapName. specifying the mapName, documentName and either of the or documentObject or documentLink and filePathType are mandatory. The supported values for the filePathType are ABSOLUTE, RELATIVE.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `document` - String - Document
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping Document is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'document' JSON :
      {
      "documentIntendedPurpose": "",
      "userData": null,
      "documentReferenceNumber": "",
      "documentType": "",
      "documentName": "",
      "documentApprovedBy": "",
      "documentObject": "",
      "approvalRequired": false,
      "documentOwner": "",
      "documentLink": "",
      "filePathType":"",
      "documentId": 0,
      "documentReference": "",
      "documentStatus": "",
      "documentApprovedDate": 1460701213000
      }

    Since:
      7.0

  - ### getProjectsAs

    public String getProjectsAs(String depth, String outputFormat)
    Returns the projects and its Details according to the specified Depth.
    Specifying the depth is mandatory. Depth has values NAMES, NAMES_IDS, DETAILS, DETAILS_DOCUMENTS, DETAILS_PROJECT_RESOURCES, ALL.
    NAMES - Returns the names of the Projects.
    NAMES_IDS - Returns the names and projectIds.
    DETAILS - Returns the projectDetails.
    DETAILS_DOCUMENTS - Returns the projectDetails and projectDocuments.
    DETAILS_PROJECT_RESOURCES - Returns the projectDetails and projectResources.
    ALL - Returns the projectDetails, projectDocuments and projectResources.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `depth` - Node Object - valid depth types are NAMES, NAMES_IDS, DETAILS, DETAILS_DOCUMENTS, DETAILS_PROJECT_RESOURCES, ALL.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If projectDetails are returned successfully,it returns success message otherwise returns failure message.
    Since:
      7.0

  - ### uploadMappingAs

    public String uploadMappingAs(int mapId, String mappingImportHelperObjJson, String outputFormat)
    Uploads the mappingSpecifications on the specified mapId and of the importFileType, importType specified in MappingImportHelper Object.
    Specifying the mapId, importFileType, importType, filePath and filePathType are mandatory.
    Valid importFileType is only MAPPINGMANAGER_EXCEL and importType can be APPEND_TO_EXISTING or DELETE_AND_RELOAD. The supported values for the filePathType are ABSOLUTE, RELATIVE.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapId` - int
      `mappingImportHelperObjJson` - mappingImportHelper Object
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If uploadMapping is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingImportHelperJsonObj' JSON :
      {
      "filePath": "",
      "filePathType" : "", "importFileType": "",
      "importType": "",
      "mailComments": null,
      "headerString": "",
      "treatFirstRowAsHeader": false
      }

    Since:
      7.0

  - ### uploadMappingAs

    public String uploadMappingAs(int nodeId, String nodeType, String mappingImportHelperObjJson, String outputFormat)
    Uploads the mappingSpecifications on the specified nodeId, nodeType and of the importFileType, importType specified in MappingImportHelper Object.
    Specifying the nodeId, nodeType, importFileType, importType, filePath, filePathType are mandatory. The supported values for the filePathType are ABSOLUTE, RELATIVE.
    Valid importFileTypes are MAPPINGMANAGER_LEGACY_EXCEL, MAPPINGMANAGER_XML, INFORMATICA, DATASTAGE, SSIS_2008 and importType can be APPEND_TO_EXISTING or DELETE_AND_RELOAD.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mappingImportHelperObjJson` - mappingImportHelper Object
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If uploadMapping is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingImportHelperJsonObj' JSON :
      {
      "filePath": "",
      "filePathType" : "", "importFileType": "",
      "importType": "",
      "mailComments": null,
      "headerString": "",
      "treatFirstRowAsHeader": false
      }

    Since:
      7.0

  - ### deleteMappingSpecificationRowAs

    public String deleteMappingSpecificationRowAs(String mappingSpecificationRowJsonObj, String outputFormat)
    Deletes the mappingSpecificationRow for the specified mappingSpecificationRow Object.
    Specifying the mappingSequenceId and mapId are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mappingSpecificationRowJsonObj` - String - mappingSpecificationRow Object
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If deletion of mappingSpecificationRow is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingSpecificationRowJsonObj' JSON :
      {
      "mappingId":0,
      "mappingSequenceId":0 }

    Since:
      7.0

  - ### deleteMappingSpecificationRowsAs

    public String deleteMappingSpecificationRowsAs(String mappingSpecificationRowsJsonArray, String outputFormat)
    Deletes the mappingSpecifications for the specified List of mappingSpecificationRows.
    Specifying the mappingSequenceIds and mapId are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mappingSpecificationRowsJsonArray` - String - mappingSpecificationRows List
      `outputFormat` - String deleteMappingSpecificationRowAs
    Returns:
      String - If deletion of mappingSpecificationRows are successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingSpecificationRowsJsonArray' JSON :
      [{
      "mappingId":0,
      "mappingSequenceId":0 },
      {
      "mappingId":0,
      "mappingSequenceId":0 }]

    Since:
      7.0

  - ### deleteMappingsAs

    public String deleteMappingsAs(int nodeId, String nodeType, String mapNamesJsonArray, String versionMode, float versionNo, String outputFormat)
    Deletes the mappings of the specified List of mapNames of the given nodeType and nodeId.
    Specifying the mapNames, nodeType, nodeId, versionMode are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
    ALL_VERSIONS - Deletes all mappings.
    CURRENT_VERSION - Deletes the present/current version.
    SPECIFIC_VERSION - Deletes a particular version.
    If the versionMode is SPECIFIC_VERSION , specifying the versionNo is mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT.
      `mapNamesJsonArray` - String - List of mapNames
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` - float
      `outputFormat` - String deleteMappingSpecificationRowAs
    Returns:
      String - If deletion of mappings is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### deleteMappingAs

    public String deleteMappingAs(int mapId, String versionMode, float versionNo, String outputFormat)
    Deletes the mapping of the specified mapId and versionMode. Specifying the mapId, versionMode are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
    ALL_VERSIONS - Deletes all mappings.
    CURRENT_VERSION - Deletes the present/current version.
    SPECIFIC_VERSION - Deletes a particular version.
    If the versionMode is SPECIFIC_VERSION , specifying the versionNo is mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapId` - int
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` - float
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If deletion of mapping is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### createSubject

    public RequestStatus createSubject(int projectId, int parentSubjectId, String subjectName)
    Creates Subject for the specified ProjectId, ParentSubjectId and SubjectName. Specifying ProjectId, SubjectName are Mandatory. If Subject details are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `projectId` - int
      `parentSubjectId` - int
      `subjectName` - String
    Returns:
      RequestStatus object
    Since:
      8.1

  - ### createSubject

    public RequestStatus createSubject(int projectId, int parentSubjectId, String subjectName, String subjectDescription)
    Creates Subject for the specified ProjectId, ParentSubjectId, SubjectName and Subject Description. Specifying ProjectId, Subject Name are Mandatory. If Subject details are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `projectId` - int
      `parentSubjectId` - int
      `subjectName` - String
      `subjectDescription` - String
    Returns:
      RequestStatus object
    Since:
      8.1

  - ### createSubjectAs

    public String createSubjectAs(int projectId, int parentSubjectId, String subjectName, String outputFormat)
    Creates Subject for the specified ProjectId, ParentSubjectId and subjectName in JSON. outputFormat can be JSON or XML.
    Specifying projectId,subjectName are Mandatory to create a subject.
    Parameters:
      `projectId` - int
      `parentSubjectId` - int
      `subjectName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Subject is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      8.1

  - ### createSubjectAs

    public String createSubjectAs(int projectId, int parentSubjectId, String subjectName, String subjectDescription, String outputFormat)
    Creates Subject for the specified ProjectId, ParentSubjectId, SubjectName and SubjectDescription in JSON. outputFormat can be JSON or XML.
    Specifying projectId , subjectName are Mandatory to create a subject.
    Parameters:
      `projectId` - int
      `parentSubjectId` - int
      `subjectName` - String
      `subjectDescription` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Subject is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      8.1

  - ### publishMappings

    public RequestStatus publishMappings(List<Integer> mapIds, Date effectiveDate, String changeDescription, String publishNotes)
    Mappings will be published for the specified mapIds. specifying the mapIds, effectiveDate, changeDescription, publishNotes are mandatory.
    Parameters:
      `mapIds` -
      `effectiveDate` -
      `changeDescription` -
      `publishNotes` -
    Returns:
      RequestStatus Object
    Since:
      8.3

  - ### publishMappingsAs

    public String publishMappingsAs(String mapIdsJsonArray, Date effectiveDate, String changeDescription, String publishNotes, String outputFormat)
    Mappings will be published for the specified mapIds in the JSON.
    specifying the mapIds, effectiveDate, changed description and publish notes are mandatory along with the other details.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapIdsJsonArray` -
      `effectiveDate` -
      `changeDescription` -
      `publishNotes` -
      `outputFormat` - - Valid values: JSON or XML
    Returns:
      String - If Mappings are published successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      8.3

  - ### createMappingsAs

    public String createMappingsAs(String mappings, boolean addSpecifications, String outputFormat)
    Creates Mappings for the specified mapping objects,addSpecifications and outputFormat. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectId and mappingName are mandatory. If the value of addSpecifications is true, mappings gets created with all the specification details provided.If the value of addSpecifications is false only empty mappings with out any specifications gets created.
    Parameters:
      `mappings` - String
      `addSpecifications` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mappings are added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappings' JSON :
      [
      {
      "projectId": 0,
      "mappingName": "",
      "mappingId": 0,
      "mappingSubStateName": null,
      "publishNotes": null,
      "subjectId": -1,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 1,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 1,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ],
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": " ",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": null,
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": null,
      "sourceExtractDescription": "",
      "userDefined35": "",
      "mappingDescription": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": null,
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 0,
      "effectiveDate": null
      },
      {
      "projectId": 0,
      "mappingName": "",
      "mappingId": 0,
      "mappingSubStateName": null,
      "publishNotes": null,
      "subjectId": -1,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 1,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 1,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ],
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": " ",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": null,
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": null,
      "sourceExtractDescription": "",
      "userDefined35": "",
      "mappingDescription": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": null,
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 0,
      "effectiveDate": null
      }
      ]

    Since:
      10.2

  - ### createMappingsWithFillOptions

    public String createMappingsWithFillOptions(String mappings, int fillOptions, String outputFormat)
    Creates Mappings for the specified mapping objects and fillOptions. OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectId and mappingName are mandatory in each mapping object.
    Here fillOptions can be Integer values of either `APIConstants.MMFillOptions.MAPPING_SPECIFICATIONS` or `APIConstants.MMFillOptions.MAPPING_DOCUMENTS` or `APIConstants.MMFillOptions.MAPPING_EXTENDED_PROPERTIES` for example: If you want to add mappings along with mapping specifications and documents you need to pass the fillOptions parameter value as 3 (MAPPING_SPECIFICATIONS(1) + MAPPING_DOCUMENTS(2)).
    Parameters:
      `mappings` - String
      `fillOptions` - int
      `outputFormat` - String
    Returns:
      String
    Since:
      13.0

  - ### getSubject

    public Subject getSubject(int projectId, String subjectHierarchy) throws Exception
    Returns Subject object for the specified projectId and subjectHierarchy. Specifying the projectId and subjectHierarchy are mandatory based on which it returns all the details of subject.
    It returns all the details pertaining to the subject such as subjectId, subjectName, subjectDescription and auditHistory.
    Parameters:
      `projectId` - int
      `subjectHierarchy` - String - Example for subjectHierarchy input parameter : s1/s2/s3
    Returns:
      Subject object in the form of JSON or XML String
    Throws:
      `Exception`
    Since:
      12.1

  - ### getSubject

    public Subject getSubject(String projectName, String subjectHierarchy) throws Exception
    Returns Subject object for the specified projectName and subjectHierarchy. Specifying the projectName and subjectHierarchy are mandatory based on which it returns all the details of subject.
    It returns all the details pertaining to the subject such as subjectId, subjectName, subjectDescription and auditHistory.
    Parameters:
      `projectName` - String
      `subjectHierarchy` - String - Example for subjectHierarchy input parameter : s1/s2/s3
    Returns:
      - Subject object in the form of JSON or XML String
    Throws:
      `Exception`
    Since:
      12.1

  - ### getSubjectid

    public int getSubjectid(String projectName, String subjectHierarchy) throws Exception
    Throws:
      `Exception`

  - ### getSubjectAs

    public String getSubjectAs(int projectId, String subjectHierarchy, String outputFormat) throws Exception
    Returns Subject object for the specified projectId and subjectHierarchy. Specifying the projectId and subjectHierarchy are mandatory based on which it returns all the details of subject.
    It returns all the details pertaining to the subject such as subjectId, subjectName, subjectDescription and auditHistory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON string.
    Parameters:
      `projectId` - int
      `subjectHierarchy` - String - Example for subjectHierarchy input parameter : s1/s2/s3
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of JSON or XML string
    Throws:
      `Exception`
    Since:
      12.1

  - ### getSubjectAs

    public String getSubjectAs(String projectName, String subjectHierarchy, String outputFormat) throws Exception
    Returns Subject object for the specified projectName and subjectHierarchy. Specifying the projectName and subjectHierarchy are mandatory based on which it returns all the details of subject.
    It returns all the details pertaining to the subject such as subjectId, subjectName, subjectDescription and auditHistory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON string.
    Parameters:
      `projectName` - String
      `subjectHierarchy` - String - Example for subjectHierarchy input parameter : s1/s2/s3
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of JSON or XML string
    Throws:
      `Exception`
    Since:
      12.1

  - ### syncMetadata

    public RequestStatus syncMetadata(List<Integer> mappingIds)
    This function is used to sync the source and target metadata information in mapping specifications for the specified mappingIds. Specifying the list of mappingIds is mandatory.
    Parameters:
      `mappingIds` - List
    Returns:
      RequestStatus Object.
    Since:
      14.0

  - ### syncMetadataAs

    public String syncMetadataAs(String mapIdsJsonArray, String outputFormat)
    This function is used to sync the source and target metadata information in mapping specifications for the specified mapIds. Specifying the mapIdsJsonArray is mandatory.
    Specification of the outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapIdsJsonArray` - String
      `outputFormat` - String
    Returns:
      String - RequestStatus object in the form of JSON or XML string.
    Since:
      14.0